# __adForkJoin.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Enum import *
from graph_adForkJoin import *
class adForkJoin(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_adForkJoin
      self.parent = parent
      self.type=ATOM3Enum(['fork', 'join'], 0, 0)
      self.generatedAttributes = {'type': ('ATOM3Enum', )      }
      self.realOrder = ['type']
      self.directEditing = [1]
   def clone(self):
      cloneObject = adForkJoin( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.adForkJoinConnections(params)
         if res: return res
      if actionID == self.EDIT or actionID == self.CONNECT:
         res = self.adBranchJoinNotValid(params)
         if res: return res
      if actionID == self.EDIT or actionID == self.CONNECT:
         res = self.adForksConnectedToJoins(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def adForkJoinConnections(self, params):
      if self.type.getValue()[1] == 0:	#fork
         if len(self.in_connections_)>1:
            return ("Too many incoming connections",self)
      else:			#join
         if len(self.out_connections_)>1:
            # do not count the "adObjectFlow" objects
            numObjFlow = 0
            for obj in self.out_connections_: 
               if obj.getClass() == "adObjectFlow": numObjFlow = numObjFlow+1
            if len(self.out_connections_) - numObjFlow > 1:
               return ("Too many outgoing connections",self)
      
      

   def adBranchJoinNotValid(self, params):
      #un branch no puede estar conectado a un join, (pero si un join a un branch)
      if self.type.getValue()[1]==1:  #join
         for x in self.in_connections_:
            if x.getClass() == "adBranchToState":
               return ("A Branch cannot be connected to a Join",self)
      
      
      
      
      
      
      
      
      
      

   def adForksConnectedToJoins(self, params):
      #Si uno dos objetos adForkJoin, la nica posibilidad es que
      #el primero sea de tipo "fork" y el segundo de tipo "join".
      
      if self.type.getValue()[1]==0:  	
         for x in self.out_connections_: 	#un fork no puede tener como rama otro fork 
            if x.getClass() == "adForkJoin":
               if x.type.getValue()[1]==0:
                  return ("A Fork cannot be connected to a Fork",self)
         for x in self.in_connections_:	#un fork no puede ser una rama de un fork/join
            if x.getClass() == "adForkJoin":
               return ("A Fork cannot be connected to a Fork/Join",self)
      
      else: 			
         for x in self.out_connections_: 	#un join no puede tener como rama otro fork/join 
            if x.getClass() == "adForkJoin":
               return ("A Join cannot be connected to a Fork/Join",self)
         for x in self.in_connections_:	#un join no puede ser una rama de otro join
            if x.getClass() == "adForkJoin":
               if x.type.getValue()[1]==1:
                  return ("A Join cannot be connected to a Fork/Join",self)
      
      
      
      
      



