# __adState.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Enum import *
from graph_adState import *
class adState(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_adState
      self.parent = parent
      self.name=ATOM3String('s')
      self.keyword_= self.name
      self.type=ATOM3Enum(['action', 'activity', 'initial', 'final'], 0, 0)
      self.entryAction=ATOM3String('')
      self.exitAction=ATOM3String('')
      self.generatedAttributes = {'name': ('ATOM3String', ),
                                  'type': ('ATOM3Enum', ),
                                  'entryAction': ('ATOM3String', ),
                                  'exitAction': ('ATOM3String', )      }
      self.realOrder = ['name','type','entryAction','exitAction']
      self.directEditing = [1,1,1,1]
   def clone(self):
      cloneObject = adState( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.name
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.CONNECT:
         res = self.adStateOutgoingConnections(params)
         if res: return res
      if actionID == self.CONNECT:
         res = self.adStateIncomigConnections(params)
         if res: return res
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.changeIcon(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def adStateOutgoingConnections(self, params):
      if len(self.out_connections_)>2:
         return ("Too many outgoing connections in State", self)
      if len(self.out_connections_) == 2:
         if self.out_connections_[0].getClass() !=  "adStateToObject" and  self.out_connections_[1].getClass() !=  "adStateToObject":
            return ("Too many outgoing connections in State", self)
      
      
      
      
      
      

   def adStateIncomigConnections(self, params):
      if len(self.in_connections_)>1:
         return ("Too many incoming connections in State", self)
      

   def changeIcon(self, params):
      if self.parent.editGGLabel: return
      tval =self.type.getValue()
      tname=tval[0][tval[1]]
      cx, cy = self.graphObject_.x, self.graphObject_.y
      oldObject = self.graphObject_
      if tname == 'initial':
          from graph_adInitialState import *
          self.graphObject_=graph_adInitialState(cx, cy, self)
      elif tname == 'final':
          from graph_adFinalState import *
          self.graphObject_=graph_adFinalState(cx, cy, self)
      else:
          from graph_adState import *
          self.graphObject_=graph_adState(cx, cy, self)    
      self.graphObject_.connections = []+oldObject.connections
      oldObject.erase(self.parent,0)
      self.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.editGGLabel)
      self.parent.UMLmodel.addtag_withtag("adState", self.graphObject_.tag)
      self.graphObject_.semanticObject = oldObject.semanticObject
      
      
      



