from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_adState(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 147, 69
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"adEntryExitActions","self.semanticObject.", [], [])
        constObj.setValue(('adEntryExitActions', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'if self.semanticObject.type.getValue()[1]==0:\011#action\012   self.gf3.setVisible(0)\012   self.gf4.setVisible(0)\012   self.gf5.setVisible(0)\012   self.gf6.setVisible(0)\012elif self.semanticObject.type.getValue()[1]==1:\011#activity\012   self.gf3.setVisible(1)\012   self.gf4.setVisible(1)\012   self.gf5.setVisible(1)\012   self.gf6.setVisible(1)\012\012\012\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([1.0, 12.0, 1.0, 12.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_oval(self.translate([4.0, 4.0, 144.0, 65.0]), tags = self.tag, fill= 'yellow', outline= 'black', width= '1.0', stipple= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_oval(self.translate([75.0, 66.0, 75.0, 66.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([72.0, 3.0, 72.0, 3.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([144.0, 32.0, 144.0, 32.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([3.0, 33.0, 3.0, 33.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_text(self.translate([36.0, 17.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'entry:', justify= 'left', width= '0', stipple= '')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_text(self.translate([38.0, 47.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'exit:', justify= 'left', width= '0', stipple= '')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        if self.semanticObject: drawText = self.semanticObject.entryAction.toString(25,5)
        else: drawText = "<entryAction>"
        h = drawing.create_text(self.translate([51.0, 12.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'nw', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["entryAction"] = h
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        if self.semanticObject: drawText = self.semanticObject.name.toString(25,5)
        else: drawText = "<name>"
        h = drawing.create_text(self.translate([70.0, 32.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["name"] = h
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        if self.semanticObject: drawText = self.semanticObject.exitAction.toString(25,5)
        else: drawText = "<exitAction>"
        h = drawing.create_text(self.translate([51.0, 41.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'nw', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["exitAction"] = h
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)

    def adEntryExitActions(self):
       if self.semanticObject.type.getValue()[1]==0:	#action
          self.gf3.setVisible(0)
          self.gf4.setVisible(0)
          self.gf5.setVisible(0)
          self.gf6.setVisible(0)
       elif self.semanticObject.type.getValue()[1]==1:	#activity
          self.gf3.setVisible(1)
          self.gf4.setVisible(1)
          self.gf5.setVisible(1)
          self.gf6.setVisible(1)
       
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.adEntryExitActions()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_adState
