from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_adSwimLane(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 178, 243
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"chgSize","self.semanticObject.", [], [])
        constObj.setValue(('chgSize', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'coords = self.gf0.getCoords()\012new_coords = (coords[0], coords[1], coords[0]+self.semanticObject.sizeX.getValue(), coords[1]+self.semanticObject.sizeY.getValue())\012self.gf0.setCoords(new_coords)\012\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([1.0, 1.0, 177.0, 242.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        if self.semanticObject: drawText = self.semanticObject.Name.toString(25,5)
        else: drawText = "<Name>"
        h = drawing.create_text(self.translate([4.0, 15.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'sw', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["Name"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)

    def chgSize(self):
       coords = self.gf0.getCoords()
       new_coords = (coords[0], coords[1], coords[0]+self.semanticObject.sizeX.getValue(), coords[1]+self.semanticObject.sizeY.getValue())
       self.gf0.setCoords(new_coords)
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.chgSize()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_adSwimLane
