# __ASG_Annotation.py_____________________________________________________
from ASG import *
from ATOM3Type       import *
from ATOM3String import *
from ATOM3Text import *
class ASG_Annotation(ASG, ATOM3Type):

   def __init__(self, parent= None, ASGroot = None):
      ASG.__init__(self, 'Annotation', ASGroot, ['ASG_Annotation' ,'TextAnnotationBox' ,'TextAnnotationRound' ,'TextAnnotationRoundedBox' ,'Anchor' ,'TextAnnotation' ,'AnnotationArrow'])

      ATOM3Type.__init__(self)
      self.parent = parent
      self.author=ATOM3String('')
      self.description=ATOM3Text('\n', 60,15 )
      self.generatedAttributes = {'author': ('ATOM3String', ),
                                  'description': ('ATOM3Text', )      }
      self.realOrder = ['author','description']
      self.directEditing = [1,1]
   def clone(self):
      return self
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
   def open(self, parent, topWindowParent):
       from ATOM3 import *
       a = ATOM3(topWindowParent, 'Annotation', 0, 1, self)
       #self.writeContents(a)
       return a
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


