# __Anchor.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Boolean import *
from graph_Anchor import *
class Anchor(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Anchor
      self.parent = parent
      self.autoOptimizeArrow=ATOM3Boolean()
      self.autoOptimizeArrow.setValue((None, 1))
      self.autoOptimizeArrow.config = 0
      self.showAnchor=ATOM3Boolean()
      self.showAnchor.setValue((None, 1))
      self.showAnchor.config = 0
      self.generatedAttributes = {'autoOptimizeArrow': ('ATOM3Boolean', ),
                                  'showAnchor': ('ATOM3Boolean', )      }
      self.realOrder = ['autoOptimizeArrow','showAnchor']
      self.directEditing = [1,1]
   def clone(self):
      cloneObject = Anchor( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if actionID == self.SAVE:
         res = self.showAnchorOnSave(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.MOVE:
         res = self.optimizeArrow(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.setAnchorVisibility(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def optimizeArrow(self, params):
      if( not self.autoOptimizeArrow.getValue()[1] ): return
      
      from Utilities import optimizeLinks
      for obj in self.in_connections_:
          setSmooth = obj.isSmooth.getValue()[1]
          setCurved = obj.curveAmount.getValue()
          optimizeLinks( self.parent.cb, setSmooth=setSmooth, setCurved=setCurved, selectedLinks=[  obj.graphObject_ ], curveDirection=1 )
      
      
      
      
      
      

   def setAnchorVisibility(self, params):
      flag = bool( self.showAnchor.getValue()[1] )
      self.graphObject_.gf75.setVisible( flag )
      
      # Make all incomming arrows have the same showAnchor flag
      for obj in self.in_connections_: 
           obj.showAnchor.setValue( int( flag ) )
      
      
      

   def showAnchorOnSave(self, params):
      flag = True
      self.graphObject_.gf75.setVisible( flag )
      self.showAnchor.setValue( int( flag ) )
      
      # Make all incomming arrows have the same showAnchor flag
      for obj in self.in_connections_: 
           obj.showAnchor.setValue( int( flag ) )
      
      
      



