# __AnnotationArrow.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Boolean import *
from ATOM3Integer import *
from graph_AnnotationArrow import *
class AnnotationArrow(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_AnnotationArrow
      self.parent = parent
      self.showAnchor=ATOM3Boolean()
      self.showAnchor.setValue((None, 1))
      self.showAnchor.config = 0
      self.isSmooth=ATOM3Boolean()
      self.isSmooth.setValue((None, 1))
      self.isSmooth.config = 0
      self.curveAmount=ATOM3Integer(10)
      self.generatedAttributes = {'showAnchor': ('ATOM3Boolean', ),
                                  'isSmooth': ('ATOM3Boolean', ),
                                  'curveAmount': ('ATOM3Integer', )      }
      self.realOrder = ['showAnchor','isSmooth','curveAmount']
      self.directEditing = [1,1,1]
   def clone(self):
      cloneObject = AnnotationArrow( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.setAnchorVisibility(params)
         if res: return res
      if actionID == self.DELETE or actionID == self.DISCONNECT:
         res = self.onDelete(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def setAnchorVisibility(self, params):
      for obj in self.out_connections_: # <--- All 1 out_connections_
                g = obj.graphObject_
                flag = bool( self.showAnchor.getValue()[1] )
                g.gf75.setVisible( flag )
      
                obj.showAnchor.setValue( int( flag ) )  # <-- Set the anchor's flag too
      
                for otherObj in obj. in_connections_: #<-- Potentially other arrows use this anchor
                   otherObj.showAnchor.setValue( int( flag ) )
      
      
      
      
      
      
      

   def onDelete(self, params):
      # Remove the anchor if no one else is using it.
      for obj in self.out_connections_:
        if( len( obj.in_connections_ ) == 0 ):
          try:
            self.parent.deleteRealEntity( obj.graphObject_.tag )       
          except:
            pass
      
      
      
      
      
      
      
      
      



