# __TextAnnotation.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Text import *
from ATOM3Boolean import *
from ATOM3Integer import *
from ATOM3String import *
from graph_TextAnnotation import *
class TextAnnotation(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_TextAnnotation
      self.parent = parent
      self.text=ATOM3Text('T\n', 60,15 )
      self.autoOptimizeArrow=ATOM3Boolean()
      self.autoOptimizeArrow.setValue((None, 1))
      self.autoOptimizeArrow.config = 0
      self.fontSize=ATOM3Integer(12)
      self.fontColor=ATOM3String('black')
      self.generatedAttributes = {'text': ('ATOM3Text', ),
                                  'autoOptimizeArrow': ('ATOM3Boolean', ),
                                  'fontSize': ('ATOM3Integer', ),
                                  'fontColor': ('ATOM3String', )      }
      self.realOrder = ['text','autoOptimizeArrow','fontSize','fontColor']
      self.directEditing = [1,1,1,1]
   def clone(self):
      cloneObject = TextAnnotation( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.MOVE:
         res = self.optimizeArrow(params)
         if res: return res
      if actionID == self.CREATE or actionID == self.MOVE:
         res = self.setAnchor(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def optimizeArrow(self, params):
      if( not self.autoOptimizeArrow.getValue()[1] ): return
      
      from Utilities import optimizeLinks
      for obj in self.out_connections_:
          setSmooth = obj.isSmooth.getValue()[1]
          setCurved = obj.curveAmount.getValue()
          optimizeLinks( self.parent.cb, setSmooth=setSmooth, setCurved=setCurved,  selectedLinks=[  obj.graphObject_ ], curveDirection=1 )
            
      
      
      
      
      

   def setAnchor(self, params):
      for obj in self.out_connections_:
         x,y = obj.graphObject_.getCenterCoord()
      
         if( y > self.graphObject_.y ):  
             self.graphObject_.gf53.setAnchor( 's' )
         else: 
             self.graphObject_.gf53.setAnchor( 'n' )
      
      
      
      
      
      
      
      
      
      
      



