# __TextAnnotationRound.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Text import *
from ATOM3Float import *
from ATOM3Boolean import *
from graph_TextAnnotationRound import *
class TextAnnotationRound(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_TextAnnotationRound
      self.parent = parent
      self.text=ATOM3Text('\n', 60,15 )
      self.charWidth=ATOM3Float(8.3)
      self.charHeight=ATOM3Float(28.0)
      self.autoResize=ATOM3Boolean()
      self.autoResize.setValue((None, 1))
      self.autoResize.config = 0
      self.autoOptimizeArrow=ATOM3Boolean()
      self.autoOptimizeArrow.setValue((None, 1))
      self.autoOptimizeArrow.config = 0
      self.generatedAttributes = {'text': ('ATOM3Text', ),
                                  'charWidth': ('ATOM3Float', ),
                                  'charHeight': ('ATOM3Float', ),
                                  'autoResize': ('ATOM3Boolean', ),
                                  'autoOptimizeArrow': ('ATOM3Boolean', )      }
      self.realOrder = ['text','charWidth','charHeight','autoResize','autoOptimizeArrow']
      self.directEditing = [1,1,1,1,1]
   def clone(self):
      cloneObject = TextAnnotationRound( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.MOVE:
         res = self.optimizeArrow(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.fitText(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def optimizeArrow(self, params):
      if( not self.autoOptimizeArrow.getValue()[1] ): return
      
      from Utilities import optimizeLinks
      for obj in self.out_connections_:
          setSmooth = obj.isSmooth.getValue()[1]
          setCurved = obj.curveAmount.getValue()
          optimizeLinks( self.parent.cb, setSmooth=setSmooth, setCurved=setCurved,  selectedLinks=[  obj.graphObject_ ], curveDirection=1 )
            
      
      
      
      

   def fitText(self, params):
      if( not self.autoResize.getValue()[1] ): return
      
      self.graphObject_.fitNodeToText( self.text.getValue(), self.charHeight.getValue(), self.charWidth.getValue() )
      
      self.optimizeArrow( None )
      
      



