import tkFont

from graphEntity     import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_TextAnnotationBox(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 60, 21
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []
        self.imageDict = self.getImageDict()

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([12.485148514851485, 19.999999999999964, 12.485148514851485, 19.999999999999964]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([30.0, 19.999999999999964, 30.0, 19.999999999999964]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([47.514851485148498, 19.999999999999964, 47.514851485148498, 19.999999999999964]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([46.940594059405939, 1.0000000000000002, 46.940594059405939, 1.0000000000000002]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([29.425742574257452, 1.0000000000000002, 29.425742574257452, 1.0000000000000002]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([11.910891089108912, 1.0000000000000002, 11.910891089108912, 1.0000000000000002]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([1.0000000000000002, 15.88333333333332, 1.0000000000000002, 15.88333333333332]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([1.0000000000000002, 5.1166666666666556, 1.0000000000000002, 5.1166666666666556]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([59.0, 15.88333333333332, 59.0, 15.88333333333332]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([59.0, 5.1166666666666556, 59.0, 5.1166666666666556]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_rectangle(self.translate([1.0000000000000002, 1.0000000000000002, 59.0, 19.999999999999964]), tags = self.tag, stipple = '', width = 1, outline = 'black', fill = 'white')
        self.gf28 = GraphicalForm(drawing, h, "gf28")
        self.graphForms.append(self.gf28)

        if self.semanticObject: drawText = self.semanticObject.text.toString(80,10)
        else: drawText = "<text>"
        font = tkFont.Font( family='Helvetica', size=12, weight='normal', slant='roman', underline=0)
        h = drawing.create_text(self.translate([2.1485148514851478, 2.266666666666671]), tags = self.tag, font=font, fill = 'black', anchor = 'nw', text = drawText, width = '0', justify= 'left', stipple='' )
        self.attr_display["text"] = h
        self.gf29 = GraphicalForm(drawing, h, 'gf29', fontObject=font)
        self.graphForms.append(self.gf29)



    def postCondition( self, actionID, * params):
        return None

    def preCondition( self, actionID, * params):
        return None

    def getImageDict( self ):
        imageDict = dict()

        return imageDict

new_class = graph_TextAnnotationBox
