import tkFont

from graphEntity     import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_TextAnnotationRound(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 62, 25
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []
        self.imageDict = self.getImageDict()

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([17.564417177914141, 22.014925373134353, 17.564417177914141, 22.014925373134353]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([1.368098159509205, 11.835820895522406, 1.368098159509205, 11.835820895522406]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([60.999999999999979, 12.164179104477617, 60.999999999999979, 12.164179104477617]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([45.171779141104331, 21.686567164179152, 45.171779141104331, 21.686567164179152]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([45.171779141104331, 2.6417910447761259, 45.171779141104331, 2.6417910447761259]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([17.564417177914141, 2.3134328358208975, 17.564417177914141, 2.3134328358208975]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([1.0000000000000002, 1.0000000000000002, 60.999999999999979, 23.000000000000018]), tags = self.tag, stipple = '', width = 1, outline = 'black', fill = 'white')
        self.gf48 = GraphicalForm(drawing, h, "gf48")
        self.graphForms.append(self.gf48)

        if self.semanticObject: drawText = self.semanticObject.text.toString(80,10)
        else: drawText = "<text>"
        font = tkFont.Font( family='Helvetica', size=12, weight='normal', slant='roman', underline=0)
        h = drawing.create_text(self.translate([6.3619631901840545, 6.5970149253731378]), tags = self.tag, font=font, fill = 'black', anchor = 'nw', text = drawText, width = '0', justify= 'left', stipple='' )
        self.attr_display["text"] = h
        self.gf49 = GraphicalForm(drawing, h, 'gf49', fontObject=font)
        self.graphForms.append(self.gf49)



    def postCondition( self, actionID, * params):
        return None

    def preCondition( self, actionID, * params):
        return None

    def getImageDict( self ):
        imageDict = dict()

        return imageDict

new_class = graph_TextAnnotationRound
