import tkFont

from graphEntity     import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_TextAnnotationRoundedBox(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 62, 26
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []
        self.imageDict = self.getImageDict()

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([12.086956521739134, 24.0, 12.086956521739134, 24.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([29.318840579710141, 24.0, 29.318840579710141, 24.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([46.550724637681185, 24.0, 46.550724637681185, 24.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([12.086956521739134, 2.0000000000000004, 12.086956521739134, 2.0000000000000004]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([29.318840579710141, 2.0000000000000004, 29.318840579710141, 2.0000000000000004]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([46.550724637681185, 2.0000000000000004, 46.550724637681185, 2.0000000000000004]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([60.0, 13.0, 60.0, 13.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([2.0000000000000004, 13.0, 2.0000000000000004, 13.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_polygon(self.translate([2.0000000000000004, 13.0, 2.0000000000000004, 13.0, 2.0000000000000004, 5.666666666666635, 7.8000000000000043, 2.0000000000000004, 31.0, 2.0000000000000004, 54.199999999999982, 2.0000000000000004, 60.0, 5.666666666666635, 60.0, 13.0, 60.0, 20.333333333333282, 54.199999999999982, 24.0, 31.0, 24.0, 7.8000000000000043, 24.0, 2.0000000000000004, 20.333333333333282]), tags = self.tag, stipple = '', width = 1, outline = 'black', fill = 'white', smooth = 'True', splinesteps =  '12')
        self.gf60 = GraphicalForm(drawing, h, "gf60")
        self.graphForms.append(self.gf60)

        if self.semanticObject: drawText = self.semanticObject.text.toString(80,10)
        else: drawText = "<text>"
        font = tkFont.Font( family='Helvetica', size=12, weight='normal', slant='roman', underline=0)
        h = drawing.create_text(self.translate([4.1014492753623237, 3.6500000000000004]), tags = self.tag, font=font, fill = 'black', anchor = 'nw', text = drawText, width = '0', justify= 'left', stipple='' )
        self.attr_display["text"] = h
        self.gf61 = GraphicalForm(drawing, h, 'gf61', fontObject=font)
        self.graphForms.append(self.gf61)



    def postCondition( self, actionID, * params):
        return None

    def preCondition( self, actionID, * params):
        return None

    def getImageDict( self ):
        imageDict = dict()

        return imageDict

new_class = graph_TextAnnotationRoundedBox
