# __Block.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Enum import *
from ATOM3Float import *
from ATOM3String import *
from ATOM3Port import *
from graph_Block import *
class Block(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Block
      self.parent = parent
      self.Name=ATOM3String('B')
      self.keyword_= self.Name
      self.Type=ATOM3Enum(['Adder', 'Inverter', 'Product', 'Inverse', 'Integral', 'Derivate'], 0, 0)
      self.Value=ATOM3Float(0.0)
      self.InitialCondition = []
      self.Variable = []
      self.generatedAttributes = {'Type': ('ATOM3Enum', ),
                                  'Value': ('ATOM3Float', ),
                                  'Name': ('ATOM3String', )      }
      self.realOrder = ['Type','Value','Name']
      self.directEditing = [1,1,1,1,1]
   def clone(self):
      cloneObject = Block( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.changeIcon(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def changeIcon(self, params):
      if self.parent.editGGLabel: return
      tval =self.Type.getValue()
      tname=tval[0][tval[1]]
      cx, cy = self.graphObject_.x, self.graphObject_.y
      oldObject = self.graphObject_
      if tname == 'Adder':
         from graph_Adder import *
         self.graphObject_=graph_Adder(cx, cy, self)
      elif tname == 'Inverter':
         from graph_Inverter import *
         self.graphObject_=graph_Inverter(cx, cy, self)
      elif tname == 'Product':
         from graph_Product import *
         self.graphObject_=graph_Product(cx, cy, self)
      elif tname == 'Inverse':
         from graph_Inverse import *
         self.graphObject_=graph_Inverse(cx, cy, self)
      elif tname == 'Integral':
         from graph_Integral import *
         self.graphObject_=graph_Integral(cx, cy, self)
      elif tname == 'Derivate':
         from graph_Derivate import *
         self.graphObject_=graph_Derivate(cx, cy, self)
      self.graphObject_.connections = []+oldObject.connections
      oldObject.erase(self.parent,0)
      self.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.editGGLabel)
      self.parent.UMLmodel.addtag_withtag("Block", self.graphObject_.tag)
      self.graphObject_.semanticObject = oldObject.semanticObject
      
      
      



