# __Output.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Enum import *
from ATOM3Port import *
from graph_Output import *
class Output(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Output
      self.parent = parent
      self.Type=ATOM3Enum(['Print', 'Plot'], 0, 0)
      self.Location=ATOM3Enum(['NW', 'N', 'NE', 'W', 'C', 'E', 'SW', 'S', 'SE'], 0, 0)
      self.Independent = []
      self.Dependent = []
      self.generatedAttributes = {'Type': ('ATOM3Enum', ),
                                  'Location': ('ATOM3Enum', )      }
      self.realOrder = ['Type','Location']
      self.directEditing = [1,0,1,1]
   def clone(self):
      cloneObject = Output( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


