# _ genOOCSMP.py ____________________________________________________________________________
# genOOCSMP : a class that subclasifies GraphGrammar. File generated automatically by ATOM3.
# ___________________________________________________________________________________________
from GraphGrammar import *
from genConstants import *
from genEquations import *
from genOutput_Blocks import *
class genOOCSMP (GraphGrammar):
   def __init__ (self, parent):
      GraphGrammar.__init__(self, [genConstants(parent) , genEquations(parent) , genOutput_Blocks(parent)])
   def initialAction(self, graph):
      lastLabel = 0
      import string
      for typ in graph.listNodes.keys():
         for node in graph.listNodes[typ]:
            node.generated = 0				# create the attribute
      # open the file (1st, compose the fileName...)
      stb   = self.rewritingSystem.parent.statusbar
      state = stb.getState(stb.MODEL)
      fileN = state[1][0]
      newFN = os.path.splitext(fileN)
      self.rewritingSystem.fileGen=open(newFN[0]+".csm", "w+t")
      self.rewritingSystem.dynamic = 0			# if the dynamic section has been generated
      # write name of model and author (if any)...
      name   = graph.Model_Name.toString()
      author = graph.Author.toString()
      if name != "": 
        self.rewritingSystem.fileGen.write("TITLE "+name+"\n")
      if author != "": 
        self.rewritingSystem.fileGen.write("* Author: "+author+"\n")
      
      
      
      
      
      
      
      
      
      
      

   def finalAction(self, graph):
      import string
      # delete the 'visited' attribute
      for ntype in graph.listNodes.keys():
        for node in graph.listNodes[ntype]:
          del node.generated
      self.rewritingSystem.fileGen.write("TIMER ")
      writed = 0
      delta=graph.Delta.toString()
      if delta: 
         self.rewritingSystem.fileGen.write("delta:= "+delta)
         writed = 1
      pl_delta=graph.Plot_delta.toString()
      if pl_delta:
         if writed: self.rewritingSystem.fileGen.write(",")
         self.rewritingSystem.fileGen.write("PLdelta:= "+ pl_delta)
         writed = 1
      pr_delta=graph.Print_delta.toString()
      if pr_delta:
         if writed: self.rewritingSystem.fileGen.write(",")
         self.rewritingSystem.fileGen.write("PRdelta:= "+ pr_delta)
         writed = 1
      fintim     =graph.Final_Time.toString()
      if fintim:
         if writed: self.rewritingSystem.fileGen.write(",")
         self.rewritingSystem.fileGen.write("FINTIM:= "+fintim)
         writed = 1
      self.rewritingSystem.fileGen.write("\n")
      self.rewritingSystem.fileGen.close()
      del self.rewritingSystem.fileGen
      
      
      
      
      
      
      
      
      

