from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Output(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 87, 45
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([18.0, 1.0, 77.0, 29.0]), tags = self.tag, fill= 'lightblue', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_rectangle(self.translate([3.0, 21.0, 44.0, 42.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', width= '1.0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_rectangle(self.translate([47.0, 21.0, 84.0, 42.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', width= '1.0', stipple= '')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        h = drawing.create_oval(self.translate([23.0, 42.0, 23.0, 42.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Independent"
        h = drawing.create_text(self.translate([66.0, 32.0]), tags = self.tag, fill= 'black', anchor= 'center', font= 'Helvetica -12', text= 'DEP', justify= 'left', width= '0', stipple= '')
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_oval(self.translate([66.0, 42.0, 66.0, 42.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Dependent"
        h = drawing.create_oval(self.translate([84.0, 32.0, 84.0, 32.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Dependent"
        h = drawing.create_oval(self.translate([3.0, 31.0, 3.0, 31.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Independent"
        h = drawing.create_text(self.translate([25.0, 32.0]), tags = self.tag, fill= 'black', anchor= 'center', font= 'Helvetica -12', text= 'INDEP', justify= 'left', width= '0', stipple= '')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        if self.semanticObject: drawText = self.semanticObject.Type.toString(25,5)
        else: drawText = "<Type>"
        h = drawing.create_text(self.translate([47.0, 13.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 10', justify= 'left', width= '0', stipple= '')
        self.attr_display["Type"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Output
