# __OOCBD_Block.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3MSEnum import *
from ATOM3Port import *
from graph_OOCBD_Block import *
class OOCBD_Block(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_OOCBD_Block
      self.parent = parent
      self.Name=ATOM3String('')
      self.keyword_= self.Name
      self.Value=ATOM3String('')
      self.Type=ATOM3MSEnum(['ADDER', 'INVERTER', 'PRODUCT', 'DIVISION', 'SIN', 'COS', 'TAN', 'ARSIN', 'ARCOS', 'ATAN', 'SH', 'CH', 'TANH', 'ARCSH', 'ARCCH', 'ARCTH', 'EXP', 'LOG', 'LOG10', 'SQRT', 'GAMMA', 'ABS', 'MAX', 'MIN', 'INTGRL', 'DERIVATIVE', 'STEP', 'RAMP', 'IMPULS', 'SAMPLE', 'PULSE', 'SAWTH', 'SINE', 'RNDGEN', 'RNDGEN', 'GAUSS', 'LIMIT', 'DEADSP', 'QNTZR', 'HSTRSS', 'AFGEN', 'NLFGEN', 'FUNGEN', 'SLOPE', 'NOT', 'AND', 'IOR', 'EOR', 'NAND', 'NOR', 'RST', 'FFJK', 'INSW', 'FCNSW', 'OUTSW', 'ZHOLD', 'DELAY', 'IMPL', 'COMPAR', 'EQUIV'], [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], 0, 1)
      self.iPort_1 = []
      self.iPort_2 = []
      self.iPort_3 = []
      self.iPort_4 = []
      self.iPort_5 = []
      self.iPort_6 = []
      self.oPort_1 = []
      self.generatedAttributes = {'Name': ('ATOM3String', ),
                                  'Value': ('ATOM3String', ),
                                  'Type': ('ATOM3MSEnum', )      }
      self.realOrder = ['Name','Value','Type']
      self.directEditing = [1,1,1,1,1,1,1,1,1,1]
   def clone(self):
      cloneObject = OOCBD_Block( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.changeIcon(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def changeIcon(self, params):
      if self.parent.editGGLabel: return
      tval =self.Type.getValue()
      tname = None
      for selected in range(len(tval[1])):		# get the 1st selected...
        if tval[1][selected]: tname = tval[0][selected]
      if not tname: return
      print "tname = ", tname
      cx, cy = self.graphObject_.x, self.graphObject_.y
      oldObject = self.graphObject_
      name2graphic = { "ADDER": "graph_CSMPCBD_Adder", 
                                   "INVERTER": "graph_CSMPCBD_Inverter",
                                   "PRODUCT": "graph_CSMPCBD_Product",
                                   "DIVISION": "graph_CSMPCBD_Inverse",
                                   "INTGRL": "graph_CSMPCBD_Integral",
                                   "DERIVATIVE": "graph_CSMPCBD_Derivate",
                                   "INSW": "graph_CSMPCBD_INSW"}
      
      if tname in name2graphic.keys():
         exec "from "+name2graphic[tname]+" import "+name2graphic[tname]
         self.graphObject_ = eval(name2graphic[tname]+"(cx, cy, self)")
      else: return
      self.graphObject_.connections = []+oldObject.connections
      oldObject.erase(self.parent,0)
      self.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.editGGLabel)
      self.parent.UMLmodel.addtag_withtag("Block", self.graphObject_.tag)
      self.graphObject_.semanticObject = oldObject.semanticObject
      
      
      
      
      
      
      
      
      



