from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_CSMPCBD_INSW(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 68, 55
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([2.0, 3.0, 60.0, 37.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_text(self.translate([32.0, 26.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 10', text= 'INSW', justify= 'left', width= '0', stipple= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_text(self.translate([13.0, 11.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'X1', justify= 'left', width= '0', stipple= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_text(self.translate([33.0, 11.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'X2', justify= 'left', width= '0', stipple= '')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_text(self.translate([54.0, 11.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'X3', justify= 'left', width= '0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_polygon(self.translate([2.0, 37.0, 32.0, 52.0, 59.0, 37.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', smooth= 0, splinesteps= '12', width= '1.0', stipple= '')
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_text(self.translate([30.0, 45.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'Y', justify= 'left', width= '0', stipple= '')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_oval(self.translate([11.0, 3.0, 11.0, 3.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "iPort_1"
        h = drawing.create_oval(self.translate([31.0, 3.0, 31.0, 3.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "iPort_2"
        h = drawing.create_oval(self.translate([52.0, 3.0, 52.0, 3.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "iPort_3"
        h = drawing.create_oval(self.translate([31.0, 52.0, 31.0, 52.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "oPort_1"


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_CSMPCBD_INSW
