from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_CSMPCBD_Integral(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 65, 57
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_polygon(self.translate([18.0, 2.0, 18.0, 55.0, 57.0, 35.0, 57.0, 21.0, 57.0, 21.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', smooth= 0, splinesteps= '12', width= '1.0', stipple= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_rectangle(self.translate([4.0, 2.0, 18.0, 55.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', width= '1.0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_line(self.translate([42.0, 20.0, 36.0, 13.0, 31.0, 19.0, 31.0, 41.0, 26.0, 47.0, 21.0, 40.0]), tags = self.tag, fill= 'black', joinstyle= 'round', smooth= 1, capstyle= 'butt', arrow= 'none', arrowshape= '8 10 3', splinesteps= '12', width= '2.0', stipple= '')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_text(self.translate([12.0, 15.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'IC', justify= 'left', width= '0', stipple= '')
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        h = drawing.create_oval(self.translate([36.0, 11.0, 36.0, 11.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([36.0, 46.0, 36.0, 46.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([4.0, 15.0, 4.0, 15.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "iPort_1"
        h = drawing.create_oval(self.translate([4.0, 38.0, 4.0, 38.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "iPort_2"
        h = drawing.create_text(self.translate([52.0, 28.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'O', justify= 'left', width= '0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_text(self.translate([9.0, 37.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'I', justify= 'left', width= '0', stipple= '')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        h = drawing.create_oval(self.translate([58.0, 27.0, 58.0, 27.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "oPort_1"


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_CSMPCBD_Integral
