from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_CSMPCBD_Product(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 73, 39
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_text(self.translate([28.0, 19.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'I', justify= 'left', width= '0', stipple= '')
        self.gf10 = GraphicalForm(drawing, h, "gf10")
        self.graphForms.append(self.gf10)
        h = drawing.create_oval(self.translate([24.0, 11.0, 24.0, 11.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([70.0, 19.0, 70.0, 19.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([24.0, 26.0, 24.0, 26.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([43.0, 29.0, 43.0, 29.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_polygon(self.translate([24.0, 2.0, 24.0, 37.0, 70.0, 19.0, 70.0, 19.0]), tags = self.tag, fill= 'lightgreen', outline= 'black', smooth= 0, splinesteps= '12', width= '1.0', stipple= '')
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_line(self.translate([36.0, 14.0, 43.0, 21.0, 46.0, 24.0]), tags = self.tag, fill= 'black', joinstyle= 'round', smooth= 0, capstyle= 'butt', arrow= 'none', arrowshape= '8 10 3', splinesteps= '12', width= '1.0', stipple= '')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_line(self.translate([35.0, 23.0, 45.0, 14.0]), tags = self.tag, fill= 'black', joinstyle= 'round', smooth= 0, capstyle= 'butt', arrow= 'none', arrowshape= '8 10 3', splinesteps= '12', width= '1.0', stipple= '')
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        h = drawing.create_oval(self.translate([43.0, 8.0, 43.0, 8.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_CSMPCBD_Product
