from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_OOCSBD_Output(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 99, 55
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([18.0, 1.0, 83.0, 33.0]), tags = self.tag, fill= 'lightblue', outline= 'blue', width= '2.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_rectangle(self.translate([5.0, 21.0, 46.0, 46.0]), tags = self.tag, fill= 'lightgreen', outline= 'green', width= '2.0', stipple= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_text(self.translate([26.0, 34.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 10', text= 'Indep.', justify= 'left', width= '0', stipple= '')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_rectangle(self.translate([52.0, 22.0, 95.0, 45.0]), tags = self.tag, fill= 'lightgreen', outline= 'green', width= '2.0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_text(self.translate([73.0, 34.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 10', text= 'Dep.', justify= 'left', width= '0', stipple= '')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        h = drawing.create_oval(self.translate([3.0, 32.0, 3.0, 32.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Independent"
        h = drawing.create_oval(self.translate([26.0, 47.0, 26.0, 47.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Independent"
        h = drawing.create_oval(self.translate([74.0, 45.0, 74.0, 45.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Dependent"
        h = drawing.create_oval(self.translate([96.0, 34.0, 96.0, 34.0]), tags = (self.tag, "connector"), fill= 'blue', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        self.namedConnectors[h] = "Dependent"
        if self.semanticObject: drawText = self.semanticObject.Type.toString(25,5)
        else: drawText = "<Type>"
        h = drawing.create_text(self.translate([50.0, 11.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 10', justify= 'left', width= '0', stipple= '')
        self.attr_display["Type"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_OOCSBD_Output
