# __ASG_EventGraphs.py_____________________________________________________
from ASG import *
from ATOM3Type       import *
from ATOM3String import *
from ATOM3Text import *
class ASG_EventGraphs(ASG, ATOM3Type):

   def __init__(self, parent= None, ASGroot = None):
      ASG.__init__(self, 'EventGraphs', ASGroot, ['ASG_EventGraphs' ,'eventEG' ,'variableEG' ,'simulationEG' ,'transitionEG'])

      ATOM3Type.__init__(self)
      self.parent = parent
      self.authorEG=ATOM3String('')
      self.nameEG=ATOM3String('Event Graph')
      self.descriptionEG=ATOM3Text('\n', 60,15 )
      self.generatedAttributes = {'authorEG': ('ATOM3String', ),
                                  'nameEG': ('ATOM3String', ),
                                  'descriptionEG': ('ATOM3Text', )      }
      self.realOrder = ['authorEG','nameEG','descriptionEG']
      self.directEditing = [1,1,1]
   def clone(self):
      return self
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
   def open(self, parent, topWindowParent):
       from ATOM3 import *
       a = ATOM3(topWindowParent, 'EventGraphs', 0, 1, self)
       #self.writeContents(a)
       return a
   def preCondition (self, actionID, * params):
      if actionID == self.SAVE:
         res = self.incorrectTransition(params)
         if res: return res
      if actionID == self.SAVE:
         res = self.incorrectEvent(params)
         if res: return res
      if actionID == self.SAVE:
         res = self.deletePrints(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.CREATE:
         res = self.printPrints(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def incorrectTransition(self, params):
      # Duplicated transitions
      print "incorrectTransition"
      for transition1 in self.parent.ASGroot.listNodes['transitionEG']:
      	repetedTransitions = 0
      	for transition2 in self.parent.ASGroot.listNodes['transitionEG']:
       	        if transition1.in_connections_[0].nameE_EG.getValue() == transition2.in_connections_[0].nameE_EG.getValue() and transition1.out_connections_[0].nameE_EG.getValue() == transition2.out_connections_[0].nameE_EG.getValue(): 
      			repetedTransitions = repetedTransitions + 1      
      			if repetedTransitions > 1: return ("Duplicated transitions",transition1) 		        
      
      
      
      
      
      
      
      
      

   def incorrectEvent(self, params):
      # Duplicated events
      print "evalEvents"
      for event1 in self.parent.ASGroot.listNodes['eventEG']:
      	repetedEvents = 0
      	for event2 in self.parent.ASGroot.listNodes['eventEG']:
      		if event1.nameE_EG.getValue() == event2.nameE_EG.getValue(): 
      			repetedEvents = repetedEvents + 1      
      			if repetedEvents > 1: return ("Duplicated events",event1) 		        
      
      
      
      
      
      
      

   def deletePrints(self, params):
      print "deletePrints"
      #for simulation in self.parent.ASGroot.listNodes['simulationEG']:
      #	simulation.printQueue.setValue('')
      #	#simulation.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.ASGroot.editGGLabel)
      #	simulation.graphObject_.DrawObject(self.parent.UMLmodel)
      #for event in self.parent.ASGroot.listNodes['eventEG']:
      #	event.printActions.setValue('')
      #	#event.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.ASGroot.editGGLabel)
      #	event.graphObject_.DrawObject(self.parent.UMLmodel)
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

   def printPrints(self, params):
      print "printPrints"
      #for simulation in self.parent.ASGroot.listNodes['simulationEG']:
      #	simulation.printQueue.setValue("exklakls")
      #	simulation.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.ASGroot.editGGLabel)
      #for event in self.parent.ASGroot.listNodes['eventEG']:
      #	event.printActions.setValue("dos")
      #	event.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.ASGroot.editGGLabel)
      
      
      
      
      
      
      
      
      
      
      



