# **********************************************************************************************
# Event Graphs Simulation API
# Author: Ricardo Riolobos Sanz
# Fecha: 02/2003
# **********************************************************************************************
from random import randint

# ----------------------------------------------------------------------------------------------
# Simulation functions
# ----------------------------------------------------------------------------------------------



# **********************************************************************************************
# Simulation until end
def SimulateEventGraphs(self):

    # Graph error
    ret = validationEG(self)
    if ret < 0:
        if ret == -1:
            print ("Event in queue is not created")
        elif ret == -2:
            print ("Duplicated transtions")
        else:
            print ("Duplicated events")
        return (-1)


    ##############################################################################
    # Main loop 
    for simulationEG in self.ASGroot.listNodes['simulationEG']:
        if simulationEG.actualSimulationTime.getValue() == 0:
            print " *************** Event Graphs Simulation  -- Start -- ***************"

        # Print actual simulation state
        #eventCounter(self)
        #transitionCounter(self)
        #printDescriptionEG(self)
        #printEventsQueueEG(self)
        printVariableEG(self)
        #printConnetions(self)

        while simulationEG.actualSimulationTime.getValue() < simulationEG.finalSimulationTime.getValue():
            simulationEG.graphObject_.DrawObject(self.UMLmodel)
            
            print "############### TIME: " + str(simulationEG.actualSimulationTime.getValue())
        
            # Get events for this time
            num_events = 1
            while num_events <> 0:
                num_events  = 0
                # Actions evaluation
                for event1 in simulationEG.eventsQueueEG.getValue():
                    tmpevent = event1.getValue()
                    if str(tmpevent[1].getValue()) == str(simulationEG.actualSimulationTime.getValue()):
                        num_events = 1
                        print " Event from queue: " + tmpevent[0].getValue() + " -- Time: " + str(tmpevent[1].getValue())
                        for event2 in self.ASGroot.listNodes['eventEG']:
                            if event2.nameE_EG.getValue() == tmpevent[0].getValue():
                                for action in event2.actionsE_EG.getValue():
                                    lengthexpression = len(action.getValue())
                                    expression = ""
                                    for variable in self.ASGroot.listNodes['variableEG']:
                                        if variable.nameV_EG.getValue() == action.getValue()[0].attrName:
                                            i = 2
                                            while i < lengthexpression:
                                                if str(action.getValue()[i].getTypeName()) == "ATOM3Attribute":
                                                    for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                        if variableTmp.nameV_EG.getValue() == action.getValue()[i].attrName:
                                                            expression = expression + str(variableTmp.valueV_EG.getValue())
                                                            break
                                                else:
                                                    expression = expression + str(action.getValue()[i].getValue())
                                                i = i + 1
                                            variable.valueV_EG.setValue(eval(expression))
                                            variable.graphObject_.DrawObject(self.UMLmodel)
                                            break
                                # Trasitions for actual event
                                for transition in self.ASGroot.listNodes['transitionEG']:
                                    if transition.in_connections_[0].nameE_EG.getValue() == event2.nameE_EG.getValue():
                                        print " Transitions: " + tmpevent[0].getValue() + " -- " + transition.out_connections_[0].nameE_EG.getValue() + " //Time: " + str(transition.delayT_EG.getValue())
                                        lengthexpression = len(transition.conditionT_EG.getValue())
                                        expression = ""
                                        i = 0
                                        while i < lengthexpression:
                                            if str(transition.conditionT_EG.getValue()[i].getValue()[0].getTypeName()) == "ATOM3Attribute":
                                                for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                    if variableTmp.nameV_EG.getValue() == transition.conditionT_EG.getValue()[i].getValue()[0].attrName:
                                                        expression = expression + str(variableTmp.valueV_EG.getValue())
                                                        break
                                            else:
                                                expression = expression + str(transition.conditionT_EG.getValue()[i].getValue()[0].getValue())
                                            i = i + 1
                                        # Add to queue new event
                                        if (eval(expression)) == 1:
                                            cobj1= self.ATOM3List([ 1, 1, 1, self.types],self.ATOM3Integer)
                                            lcobj2=[]
                                            cobj2= self.ATOM3String(str(transition.out_connections_[0].nameE_EG.getValue()))
                                            lcobj2.append(cobj2)
                                            cobj2= self.ATOM3String(str(eval(transition.delayT_EG.getValue())+simulationEG.actualSimulationTime.getValue()))
                                            lcobj2.append(cobj2)
                                            cobj1.setValue(lcobj2)
                                            simulationEG.eventsQueueEG.getValue().append(cobj1)
                        # Remove actuel event from queue
                        simulationEG.eventsQueueEG.getValue().remove(event1)

                        
            printVariableEG(self)
            simulationEG.actualSimulationTime.setValue(simulationEG.actualSimulationTime.getValue() + 1)

            simulationEG.printQueue.setValue("")
            i = 0
            for event in simulationEG.eventsQueueEG.getValue():
                if i> 0: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"\n[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
        	else: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
            i = i+1 

            simulationEG.graphObject_.DrawObject(self.UMLmodel, self.editGGLabel)

    ##############################################################################

    print " *************** Event Graphs Simulation  --  End  -- ***************"



# **********************************************************************************************
# Simulation step by step
def SimulateEventGraphsStep(self):

    # Graph error
    ret =validationEG(self)
    if ret < 0:
        if ret == -1:
            print ("Event in queue is not created")
        elif ret == -2:
            print ("Duplicated transtions")
        else:
            print ("Duplicated events")
        return (-1)


    ##############################################################################
    # Main loop 
    for simulationEG in self.ASGroot.listNodes['simulationEG']:
    
        if simulationEG.actualSimulationTime.getValue() >= simulationEG.finalSimulationTime.getValue(): return (-1)


        if simulationEG.actualSimulationTime.getValue() == 0:
            print " *************** Event Graphs Simulation  -- Start -- ***************"

        
        # Print actual simulation state
        #eventCounter(self)
        #transitionCounter(self)
        #printDescriptionEG(self)
        #printEventsQueueEG(self)
        printVariableEG(self)
        #printConnetions(self)

        print "############### TIME: " + str(simulationEG.actualSimulationTime.getValue())

        # Get events for this time
        num_events = 1
        while num_events <> 0:
            num_events  = 0
            # Actions evaluation
            for event1 in simulationEG.eventsQueueEG.getValue():
                tmpevent = event1.getValue()
                if str(tmpevent[1].getValue()) == str(simulationEG.actualSimulationTime.getValue()):
                    num_events = 1
                    print " Event from queue: " + tmpevent[0].getValue() + " -- Time: " + str(tmpevent[1].getValue())
                    for event2 in self.ASGroot.listNodes['eventEG']:
                        if event2.nameE_EG.getValue() == tmpevent[0].getValue():
                            for action in event2.actionsE_EG.getValue():
                                print "ACTION" 
                                lengthexpression = len(action.getValue())
                                expression = ""
                                for variable in self.ASGroot.listNodes['variableEG']:
                                    print str(variable.nameV_EG.getValue()) + "//" +  str(variable.valueV_EG.getValue())
                                    if variable.nameV_EG.getValue() == action.getValue()[0].attrName:
                                        i = 2
                                        while i < lengthexpression:
                                            if str(action.getValue()[i].getTypeName()) == "ATOM3Attribute":
                                                for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                    if variableTmp.nameV_EG.getValue() == action.getValue()[i].attrName:
                                                        expression = expression + str(variableTmp.valueV_EG.getValue())
                                                        break
                                            else:
                                                expression = expression + str(action.getValue()[i].getValue())
                                            i = i + 1
                                        variable.valueV_EG.setValue(eval(expression))
                                        variable.graphObject_.DrawObject(self.UMLmodel)
                                        break
                      
                            # Trasitions for actual event
                            for transition in self.ASGroot.listNodes['transitionEG']:
                                if transition.in_connections_[0].nameE_EG.getValue() == event2.nameE_EG.getValue():
                                    print " Transitions: " + tmpevent[0].getValue() + " -- " + transition.out_connections_[0].nameE_EG.getValue() + " //Time: " + str(transition.delayT_EG.getValue())
                                    lengthexpression = len(transition.conditionT_EG.getValue())
                                    expression = ""
                                    i = 0
                                    while i < lengthexpression:
                                        if str(transition.conditionT_EG.getValue()[i].getValue()[0].getTypeName()) == "ATOM3Attribute":
                                            for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                if variableTmp.nameV_EG.getValue() == transition.conditionT_EG.getValue()[i].getValue()[0].attrName:
                                                    expression = expression + str(variableTmp.valueV_EG.getValue())
                                                    break
                                        else:
                                            expression = expression + str(transition.conditionT_EG.getValue()[i].getValue()[0].getValue())
                                        i = i + 1
                                    # Add to queue new event 
                                    if (eval(expression)) == 1:
                                        cobj1= self.ATOM3List([ 1, 1, 1, self.types],self.ATOM3Integer)
                                        lcobj2=[]
                                        cobj2= self.ATOM3String(str(transition.out_connections_[0].nameE_EG.getValue()))
                                        lcobj2.append(cobj2)
                                        cobj2= self.ATOM3String(str(eval(transition.delayT_EG.getValue())+simulationEG.actualSimulationTime.getValue()))
                                        lcobj2.append(cobj2)
                                        cobj1.setValue(lcobj2)
                                        simulationEG.eventsQueueEG.getValue().append(cobj1)
                    # Remove actuel event from queue
                    simulationEG.eventsQueueEG.getValue().remove(event1)
            

                    
    printVariableEG(self)
    simulationEG.actualSimulationTime.setValue(simulationEG.actualSimulationTime.getValue() + 1)

    simulationEG.printQueue.setValue("")
    i = 0
    for event in simulationEG.eventsQueueEG.getValue():
	if i> 0: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"\n[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
	else: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
	i = i+1

    simulationEG.graphObject_.DrawObject(self.UMLmodel, self.editGGLabel)

    if simulationEG.actualSimulationTime.getValue() > simulationEG.finalSimulationTime.getValue(): 
        print " *************** Event Graphs Simulation  --  End  -- ***************"



# **********************************************************************************************
# Simulation by time
def SimulateEventGraphsByTime(self):

    # Graph error
    ret = validationEG(self)
    if ret < 0:
        if ret == -1:
            print ("Event in queue is not created")
        elif ret == -2:
            print ("Duplicated transtions")
        else:
            print ("Duplicated events")
        return (-1)


    ##############################################################################
    # Main loop 
    for simulationEG in self.ASGroot.listNodes['simulationEG']:
        if simulationEG.actualSimulationTime.getValue() == 0:
            print " *************** Event Graphs Simulation  -- Start -- ***************"

        # Print actual simulation state
        #eventCounter(self)
        #transitionCounter(self)
        #printDescriptionEG(self)
        #printEventsQueueEG(self)
        printVariableEG(self)
        #printConnetions(self)
        whereThereIsEvents = 0    
    

        while simulationEG.actualSimulationTime.getValue() < simulationEG.finalSimulationTime.getValue():
            simulationEG.graphObject_.DrawObject(self.UMLmodel)
            
            print "############### TIME: " + str(simulationEG.actualSimulationTime.getValue())
        
            # Get events for this time
            num_events = 1
            while num_events <> 0:
                num_events  = 0
                # Actions evaluation
                for event1 in simulationEG.eventsQueueEG.getValue():
                    tmpevent = event1.getValue()
                    if str(tmpevent[1].getValue()) == str(simulationEG.actualSimulationTime.getValue()):
                        num_events = 1
                        whereThereIsEvents = 1    
                        print " Event from queue: " + tmpevent[0].getValue() + " -- Time: " + str(tmpevent[1].getValue())
                        for event2 in self.ASGroot.listNodes['eventEG']:
                            if event2.nameE_EG.getValue() == tmpevent[0].getValue():
                                for action in event2.actionsE_EG.getValue():
                                    lengthexpression = len(action.getValue())
                                    expression = ""
                                    for variable in self.ASGroot.listNodes['variableEG']:
                                        if variable.nameV_EG.getValue() == action.getValue()[0].attrName:
                                            i = 2
                                            while i < lengthexpression:
                                                if str(action.getValue()[i].getTypeName()) == "ATOM3Attribute":
                                                    for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                        if variableTmp.nameV_EG.getValue() == action.getValue()[i].attrName:
                                                            expression = expression + str(variableTmp.valueV_EG.getValue())
                                                            break
                                                else:
                                                    expression = expression + str(action.getValue()[i].getValue())
                                                i = i + 1
                                            variable.valueV_EG.setValue(eval(expression))
                                            variable.graphObject_.DrawObject(self.UMLmodel)
                                            break
                                # Trasitions for actual event
                                for transition in self.ASGroot.listNodes['transitionEG']:
                                    if transition.in_connections_[0].nameE_EG.getValue() == event2.nameE_EG.getValue():
                                        print " Transitions: " + tmpevent[0].getValue() + " -- " + transition.out_connections_[0].nameE_EG.getValue() + " //Time: " + str(transition.delayT_EG.getValue())
                                        lengthexpression = len(transition.conditionT_EG.getValue())
                                        expression = ""
                                        i = 0
                                        while i < lengthexpression:
                                            if str(transition.conditionT_EG.getValue()[i].getValue()[0].getTypeName()) == "ATOM3Attribute":
                                                for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                    if variableTmp.nameV_EG.getValue() == transition.conditionT_EG.getValue()[i].getValue()[0].attrName:
                                                        expression = expression + str(variableTmp.valueV_EG.getValue())
                                                        break
                                            else:
                                                expression = expression + str(transition.conditionT_EG.getValue()[i].getValue()[0].getValue())
                                            i = i + 1
                                        # Add to queue new event
                                        if (eval(expression)) == 1:
                                            cobj1= self.ATOM3List([ 1, 1, 1, self.types],self.ATOM3Integer)
                                            lcobj2=[]
                                            cobj2= self.ATOM3String(str(transition.out_connections_[0].nameE_EG.getValue()))
                                            lcobj2.append(cobj2)
                                            cobj2= self.ATOM3String(str(eval(transition.delayT_EG.getValue())+simulationEG.actualSimulationTime.getValue()))
                                            lcobj2.append(cobj2)
                                            cobj1.setValue(lcobj2)
                                            simulationEG.eventsQueueEG.getValue().append(cobj1)
                        # Remove actuel event from queue
                        simulationEG.eventsQueueEG.getValue().remove(event1)

                        
            printVariableEG(self)
            simulationEG.actualSimulationTime.setValue(simulationEG.actualSimulationTime.getValue() + 1)
            simulationEG.printQueue.setValue("")
            i = 0
            for event in simulationEG.eventsQueueEG.getValue():
                if i> 0: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"\n[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
        	else: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
            i = i+1 

            simulationEG.graphObject_.DrawObject(self.UMLmodel, self.editGGLabel)

            if (simulationEG.actualSimulationTime.getValue() < simulationEG.finalSimulationTime.getValue()) and (whereThereIsEvents == 1):
                return (whereThereIsEvents)
    ##############################################################################

    print " *************** Event Graphs Simulation  --  End  -- ***************"



# **********************************************************************************************
# Simulation by event
def SimulateEventGraphsByEvent(self):

    # Graph error
    ret = validationEG(self)
    if ret < 0:
        if ret == -1:
            print ("Event in queue is not created")
        elif ret == -2:
            print ("Duplicated transtions")
        else:
            print ("Duplicated events")
        return (-1)


    ##############################################################################
    # Main loop 
    for simulationEG in self.ASGroot.listNodes['simulationEG']:
        if simulationEG.actualSimulationTime.getValue() == 0:
            print " *************** Event Graphs Simulation  -- Start -- ***************"

        # Print actual simulation state
        #eventCounter(self)
        #transitionCounter(self)
        #printDescriptionEG(self)
        #printEventsQueueEG(self)
        printVariableEG(self)
        #printConnetions(self)
    

        while simulationEG.actualSimulationTime.getValue() < simulationEG.finalSimulationTime.getValue():
            simulationEG.graphObject_.DrawObject(self.UMLmodel)
            
            print "############### TIME: " + str(simulationEG.actualSimulationTime.getValue())
        
            # Get events for this time
            num_events = 1
            while num_events <> 0:
                num_events  = 0
                # Actions evaluation
                for event1 in simulationEG.eventsQueueEG.getValue():
                    tmpevent = event1.getValue()
                    if str(tmpevent[1].getValue()) == str(simulationEG.actualSimulationTime.getValue()):
                        num_events = 1
                        print " Event from queue: " + tmpevent[0].getValue() + " -- Time: " + str(tmpevent[1].getValue())
                        for event2 in self.ASGroot.listNodes['eventEG']:
                            if event2.nameE_EG.getValue() == tmpevent[0].getValue():
                                for action in event2.actionsE_EG.getValue():
                                    lengthexpression = len(action.getValue())
                                    expression = ""
                                    for variable in self.ASGroot.listNodes['variableEG']:
                                        if variable.nameV_EG.getValue() == action.getValue()[0].attrName:
                                            i = 2
                                            while i < lengthexpression:
                                                if str(action.getValue()[i].getTypeName()) == "ATOM3Attribute":
                                                    for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                        if variableTmp.nameV_EG.getValue() == action.getValue()[i].attrName:
                                                            expression = expression + str(variableTmp.valueV_EG.getValue())
                                                            break
                                                else:
                                                    expression = expression + str(action.getValue()[i].getValue())
                                                i = i + 1
                                            variable.valueV_EG.setValue(eval(expression))
                                            variable.graphObject_.DrawObject(self.UMLmodel)
                                            break
                                # Trasitions for actual event
                                for transition in self.ASGroot.listNodes['transitionEG']:
                                    if transition.in_connections_[0].nameE_EG.getValue() == event2.nameE_EG.getValue():
                                        print " Transitions: " + tmpevent[0].getValue() + " -- " + transition.out_connections_[0].nameE_EG.getValue() + " //Time: " + str(transition.delayT_EG.getValue())
                                        lengthexpression = len(transition.conditionT_EG.getValue())
                                        expression = ""
                                        i = 0
                                        while i < lengthexpression:
                                            if str(transition.conditionT_EG.getValue()[i].getValue()[0].getTypeName()) == "ATOM3Attribute":
                                                for variableTmp in self.ASGroot.listNodes['variableEG']:
                                                    if variableTmp.nameV_EG.getValue() == transition.conditionT_EG.getValue()[i].getValue()[0].attrName:
                                                        expression = expression + str(variableTmp.valueV_EG.getValue())
                                                        break
                                            else:
                                                expression = expression + str(transition.conditionT_EG.getValue()[i].getValue()[0].getValue())
                                            i = i + 1
                                        # Add to queue new event
                                        if (eval(expression)) == 1:
                                            cobj1= self.ATOM3List([ 1, 1, 1, self.types],self.ATOM3Integer)
                                            lcobj2=[]
                                            cobj2= self.ATOM3String(str(transition.out_connections_[0].nameE_EG.getValue()))
                                            lcobj2.append(cobj2)
                                            cobj2= self.ATOM3String(str(eval(transition.delayT_EG.getValue())+simulationEG.actualSimulationTime.getValue()))
                                            lcobj2.append(cobj2)
                                            cobj1.setValue(lcobj2)
                                            simulationEG.eventsQueueEG.getValue().append(cobj1)
                        # Remove actuel event from queue
                        simulationEG.eventsQueueEG.getValue().remove(event1)
                        printVariableEG(self)
                        simulationEG.actualSimulationTime.setValue(simulationEG.actualSimulationTime.getValue() + 1)
                        simulationEG.printQueue.setValue("")
                        i = 0
                        for event in simulationEG.eventsQueueEG.getValue():
                            if i> 0: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"\n[Event: " + event.getValue()[0].getValue() + "  /  Time: " + event.getValue()[1].getValue()+"]")
                            else: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"[Event: " + event.getValue()[0].getValue() + "  /  Time: " + event.getValue()[1].getValue()+"]")
                        i = i+1 

                        simulationEG.graphObject_.DrawObject(self.UMLmodel, self.editGGLabel)

                        return (event1)

                        
            printVariableEG(self)
            simulationEG.actualSimulationTime.setValue(simulationEG.actualSimulationTime.getValue() + 1)
            simulationEG.printQueue.setValue("")
            i = 0
            for event in simulationEG.eventsQueueEG.getValue():
                if i> 0: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"\n[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
        	else: simulationEG.printQueue.setValue(simulationEG.printQueue.getValue()+"[" + event.getValue()[0].getValue() + " -> " + event.getValue()[1].getValue()+"]")
            i = i+1 

            simulationEG.graphObject_.DrawObject(self.UMLmodel, self.editGGLabel)

    ##############################################################################

    print " *************** Event Graphs Simulation  --  End  -- ***************"

# ----------------------------------------------------------------------------------------------
# Validation function
# ----------------------------------------------------------------------------------------------


# **********************************************************************************************
def validationEG(self):

    # Only created events
    for simulationEG in self.ASGroot.listNodes['simulationEG']:
        for eventQueue in simulationEG.eventsQueueEG.getValue(): 
            for event in self.ASGroot.listNodes['eventEG']:
                    if  eventQueue.getValue()[0].getValue() == event.nameE_EG.getValue():
                            break
            else:
                    return (-1)

    # Duplicated transitions
    for transition1 in self.ASGroot.listNodes['transitionEG']:
	repetedTransitions = 0
	for transition2 in self.ASGroot.listNodes['transitionEG']:
 	        if transition1.in_connections_[0].nameE_EG.getValue() == transition2.in_connections_[0].nameE_EG.getValue() and transition1.out_connections_[0].nameE_EG.getValue() == transition2.out_connections_[0].nameE_EG.getValue(): 
			repetedTransitions = repetedTransitions + 1      
			if repetedTransitions > 1: return (-2) 	

    # Duplicated events
    for event1 in self.ASGroot.listNodes['eventEG']:
	repetedEvents = 0
	for event2 in self.ASGroot.listNodes['eventEG']:
	#        print event1.nameE_EG.getValue()
	#        print event2.nameE_EG.getValue()
 	        if event1.nameE_EG.getValue() == event2.nameE_EG.getValue(): 
			repetedEvents = repetedEvents + 1      
			if repetedEvents > 1: return (-3) 	

    return (0)


# ----------------------------------------------------------------------------------------------
# Printer functions
# ----------------------------------------------------------------------------------------------

# **********************************************************************************************
def eventCounter(self):
    numInitials = 0
    for event in self.ASGroot.listNodes['eventEG']:
        numInitials = numInitials + 1
        print event.nameE_EG.getValue()
    print  " ** Number of events **"
    print  "   " + str(numInitials)

# **********************************************************************************************
def transitionCounter(self):
    numInitials = 0
    for state in self.ASGroot.listNodes['transitionEG']:
        numInitials = numInitials + 1
    print  " ** Number of transitions **"
    print  "   " + str(numInitials)

# **********************************************************************************************
def printDescriptionEG(self):
    print  " ** Description **"    
    print "   " + self.ASGroot.descriptionEG.getValue()

# **********************************************************************************************
def printEventsQueueEG(self):
    print  " ** Queue of events **"
    queueTmp = ""
    for simulationEG in self.ASGroot.listNodes['simulationEG']:
        for event in simulationEG.eventsQueueEG.getValue():
            tmpevent = event.getValue()
            print " Event: " + tmpevent[0].getValue() + " -- Time: " + tmpevent[1].getValue()

# **********************************************************************************************
def printVariableEG(self):
#    print  " ** State **"
    for variable in self.ASGroot.listNodes['variableEG']:
        print " Variable name: " + variable.nameV_EG.getValue() + "// Variable value " + str(variable.valueV_EG.getValue())

# **********************************************************************************************
def printConnetions(self):
    print " ------------ Transitions ----------- "
    numTransition = 1
    for transition in self.ASGroot.listNodes['transitionEG']:
        print "Transition " + str(numTransition) 
        print transition.in_connections_[0].nameE_EG.getValue()
        print transition.out_connections_[0].nameE_EG.getValue()
        numTransition = numTransition + 1 

        
