from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_eventEG(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 70, 100
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 1
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([5.0, 3.0, 66.0, 59.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'light green')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_oval(self.translate([36.0, 60.0, 36.0, 60.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([37.0, 3.0, 37.0, 3.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([67.0, 32.0, 67.0, 32.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([4.0, 31.0, 4.0, 31.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([15.0, 11.0, 15.0, 11.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([59.0, 11.0, 59.0, 11.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([14.0, 51.0, 14.0, 51.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([57.0, 51.0, 57.0, 51.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.nameE_EG.toString(25,5)
        else: drawText = "<nameE_EG>"
        h = drawing.create_text(self.translate([36.0, 29.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["nameE_EG"] = h
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        if self.semanticObject: drawText = self.semanticObject.printActions.toString(25,5)
        else: drawText = "<printActions>"
        h = drawing.create_text(self.translate([34.0, 93.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["printActions"] = h
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_eventEG
