from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_simulationEG(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 218, 154
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 1
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([1.0, 111.0, 214.0, 153.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'light blue')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_line(self.translate([3.0, 132.0, 215.0, 132.0]), tags = self.tag, stipple= '', width= '1.0', splinesteps= '12', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 0, joinstyle= 'round', fill= 'black')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_text(self.translate([56.0, 122.0]), tags = self.tag, stipple= '', width= '0', fill= 'black', text= 'Actual simulation time:', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_text(self.translate([50.0, 143.0]), tags = self.tag, stipple= '', width= '0', fill= 'black', text= 'Final simulaton time:', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_rectangle(self.translate([39.0, 1.0, 173.0, 108.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'light blue')
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        if self.semanticObject: drawText = self.semanticObject.printQueue.toString(25,5)
        else: drawText = "<printQueue>"
        h = drawing.create_text(self.translate([104.0, 55.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'black', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["printQueue"] = h
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        if self.semanticObject: drawText = self.semanticObject.finalSimulationTime.toString(25,5)
        else: drawText = "<finalSimulationTime>"
        h = drawing.create_text(self.translate([159.0, 143.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'black', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["finalSimulationTime"] = h
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        if self.semanticObject: drawText = self.semanticObject.actualSimulationTime.toString(25,5)
        else: drawText = "<actualSimulationTime>"
        h = drawing.create_text(self.translate([161.0, 121.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'black', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["actualSimulationTime"] = h
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_simulationEG
