from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_transitionEG_Center(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 164, 19
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 1
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_text(self.translate([92.0, 6.0]), tags = self.tag, stipple= '', width= '0', fill= 'blue', text= '/', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_oval(self.translate([91.0, 16.0, 91.0, 16.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.delayT_EG.toString(25,5)
        else: drawText = "<delayT_EG>"
        h = drawing.create_text(self.translate([130.0, 6.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["delayT_EG"] = h
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        if self.semanticObject: drawText = self.semanticObject.printCondition.toString(25,5)
        else: drawText = "<printCondition>"
        h = drawing.create_text(self.translate([39.0, 6.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'left')
        self.attr_display["printCondition"] = h
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_transitionEG_Center
