# __FSATransition.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from graph_FSATransition import *
class FSATransition(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_FSATransition
      self.parent = parent
      self.Input=ATOM3String('')
      self.Output=ATOM3String('')
      self.generatedAttributes = {'Input': ('ATOM3String', ),
                                  'Output': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Input').grid(row=0,column=0,sticky=W)
      self.Input.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Input', 0, 2)
      Label(self.containerFrame, text='Output').grid(row=1,column=0,sticky=W)
      self.Output.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Output', 1, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 2)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Input.toString()+' '+self.Output.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Input.getValue(),self.Output.getValue(),)

   def setValue(self, value):
      self.Input.setValue(value[0])
      self.Output.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Input.writeConstructor2File(file, indent, objName+'.Input', depth, generatingCode)
      self.Output.writeConstructor2File(file, indent, objName+'.Output', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Input.writeValue2File(file, indent, objName+'.Input', depth, generatingCode)
      self.Output.writeValue2File(file, indent, objName+'.Output', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Input.invalid() or self.Output.invalid() 

   def clone(self):
      cloneObject = FSATransition( self.parent )
      cloneObject.Input = self.Input.clone()
      cloneObject.Output = self.Output.clone()
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Input = other.Input
      self.Output = other.Output
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Input.destroy()
      self.Output.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.validInput(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.validOutput(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def validInput(self, params):
      input = self.Input.toString()
      # check that the input is the alphabet of valid inputs...
      validInputs = self.parent.ASGroot.Input_Alphabet.getValue()
      for ai in validInputs:
         if input == ai.toString(): return None
      return ("Invalid input",input)
      
      
      
      
      
      
      

   def validOutput(self, params):
      output = self.Output.toString()
      # check that the output is the alphabet of valid inputs...
      validOutputs = self.parent.ASGroot.Output_Alphabet.getValue()
      for ao in validOutputs:
         if output == ao.toString(): return None
      return ("Invalid output",output)
      
      
      
      



