from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_FSAState(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 79, 70
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"initialState","self.semanticObject.", [], [])
        constObj.setValue(('initialState', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'initial = self.semanticObject.isInitial.getValue()[1]\012if initial == 1:\012   self.gf5.setVisible(1)\012else:\012   self.gf5.setVisible(0)\012\012\012\012\012'))
        self.constraintList.append(constObj)

        constObj = ATOM3Constraint(atribs,"finalState","self.semanticObject.", [], [])
        constObj.setValue(('finalState', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'final =self.semanticObject.isFinal.getValue()[1]\012if final == 0:\012   self.gf4.setVisible(0)\012else:\012   self.gf4.setVisible(1)\012\012\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([8.0, 10.0, 57.0, 62.0]), tags = self.tag, fill= 'pink', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_oval(self.translate([8.0, 36.0, 8.0, 36.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([33.0, 63.0, 33.0, 63.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([58.0, 37.0, 58.0, 37.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([32.0, 10.0, 32.0, 10.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([1.0, 3.0, 64.0, 69.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_line(self.translate([67.0, 4.0, 52.0, 19.0, 75.0, 16.0]), tags = self.tag, fill= 'black', joinstyle= 'round', smooth= 0, capstyle= 'butt', arrow= 'none', arrowshape= '8 10 3', splinesteps= '12', width= '3.0', stipple= '')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        if self.semanticObject: drawText = self.semanticObject.Name.toString(25,5)
        else: drawText = "<Name>"
        h = drawing.create_text(self.translate([33.0, 34.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'center', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Name"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)

    def initialState(self):
       initial = self.semanticObject.isInitial.getValue()[1]
       if initial == 1:
          self.gf5.setVisible(1)
       else:
          self.gf5.setVisible(0)
       
       
       
       
       
    def finalState(self):
       final =self.semanticObject.isFinal.getValue()[1]
       if final == 0:
          self.gf4.setVisible(0)
       else:
          self.gf4.setVisible(1)
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.initialState()
         if res: return res
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.finalState()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_FSAState
