# _ genGPSSCode.py ____________________________________________________________________________
# genGPSSCode : a class that subclasifies GraphGrammar. File generated automatically by ATOM3.
# ___________________________________________________________________________________________
from GraphGrammar import *
from findRoot import *
from goDeep import *
from finishBranch import *
from startNewBranch import *
from genStorageSizes import *
from genTableSizes import *
from genFunctions import *
from genVariables import *
from genGates import *
from genTests import *
class genGPSSCode (GraphGrammar):
   def __init__ (self, parent):
      GraphGrammar.__init__(self, [findRoot(parent) , goDeep(parent) , finishBranch(parent) , startNewBranch(parent) , genStorageSizes(parent) , genTableSizes(parent) , genFunctions(parent) , genVariables(parent) , genGates(parent) , genTests(parent)])
   def initialAction(self, graph):
      # create the attribute 'visited' in each node of type GPSSBlock
      lastLabel = 0
      import string
      for typ in graph.listNodes.keys():
         for node in graph.listNodes[typ]:
            node.visited = 0				# create the attribute
            node.current=0				# flag to indicate if it is the current node
      for node in graph.listNodes['GPSSBlock']:
         if node.Label.toString() == "":		# then set the new label
            node.Label.setValue("L"+str(lastLabel))
            lastLabel=lastLabel+1
      
      # open the file (1st, compose the fileName...)
      stb   = self.rewritingSystem.parent.statusbar
      state = stb.getState(stb.MODEL)
      fileN = state[1][0]
      newFN = os.path.splitext(fileN)
      self.rewritingSystem.fileGen=open(newFN[0]+".gps", "w+t")
      # write name of model and author (if any)...
      name   = graph.Name.toString()
      author = graph.Author.toString()
      comment= string.ljust("*", 18)
      if name != "": 
        self.rewritingSystem.fileGen.write(comment+name+string.whitespace[1])
      if author != "": 
        self.rewritingSystem.fileGen.write(comment+author+string.whitespace[1])
      self.rewritingSystem.fileGen.write("       SIMULATE"+string.whitespace[1])
      
      
      
      
      
      

   def finalAction(self, graph):
      import string
      # delete the 'visited' attribute
      for ntype in graph.listNodes.keys():
        for node in graph.listNodes[ntype]:
          del node.visited
          del node.current
      blanks = "       "
      # go through control statements
      css = graph.Control_Statements.getValue()
      for st in css:
        cmnd = st.ltypename.toString()
        A = st.A.toString()
        B = st.B.toString()
        C = st.C.toString()
        self.rewritingSystem.fileGen.write(blanks+string.ljust(cmnd,11))
        if A != "":
           self.rewritingSystem.fileGen.write(A)
        if B != "" or C!="":
           self.rewritingSystem.fileGen.write(",")
        if B != "":
           self.rewritingSystem.fileGen.write(B)
        if C != "":
           self.rewritingSystem.fileGen.write(","+C)
        self.rewritingSystem.fileGen.write(string.whitespace[1])
      self.rewritingSystem.fileGen.write(blanks+"END"+string.whitespace[1])
      self.rewritingSystem.fileGen.close()
      del self.rewritingSystem.fileGen
      
      
      
      
      
      
      
      

