from Tkinter import *
from ATOM3Type import *
from ATOM3String import *
from ATOM3List import *
class ClassXParameters (ATOM3Type):
   def __init__(self):
      ATOM3Type.__init__(self)
      self.Class= None
      self.Parameters= None

   def createComponents(self):
      if not self.Class:
         self.Class=ATOM3String('')
      if not self.Parameters:
         self.Parameters=ATOM3List([ 1, 1, 1, 0],ATOM3String)
         lcobj0=[]
         self.Parameters.setValue(lcobj0)

   def show(self, parent, parentWindowInfo=None):
      self.createComponents()
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Class').grid(row=0,column=0,sticky=W)
      self.Class.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      Label(self.containerFrame, text='Parameters').grid(row=1,column=0,sticky=W)
      self.Parameters.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      return self.containerFrame

   def toString(self, fils = 5, cols = 25):
      self.createComponents()
      return  self.Class.toString()+' '+ self.Parameters.toString()
   def getValue(self):
      self.createComponents()
      return (self.Class.getValue(),self.Parameters.getValue(),)

   def setValue(self, value):
      self.createComponents()
      if value == None:
         self.Class.setNone()
         self.Parameters.setNone()
      else:
         self.Class.setValue(value[0])
         self.Parameters.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      file.write(indent+objName+'= ClassXParameters()\n')
      self.Class.writeConstructor2File(file, indent, objName+'.Class', depth, generatingCode)
      self.Parameters.writeConstructor2File(file, indent, objName+'.Parameters', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.Class.writeValue2File(file, indent, objName+'.Class', depth, generatingCode)
      self.Parameters.writeValue2File(file, indent, objName+'.Parameters', depth, generatingCode)

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = ClassXParameters()
     if self.Class: cloneObject.Class = self.Class.clone()
     if self.Parameters: cloneObject.Parameters = self.Parameters.clone()
     return cloneObject
   def destroy(self):
     "Destroys (i.e. updates) each field"
     cloneObject = ClassXParameters()
     if self.Class: self.Class.destroy()
     if self.Parameters: self.Parameters.destroy()
     return cloneObject
   def invalid(self):
     "checks whether the entity is valid or not"
     inval = 0
     if self.Class: inval = inval or self.Class.invalid()
     if self.Parameters: inval = inval or self.Parameters.invalid()
     return inval

