from Tkinter import *
from ATOM3Type import *
from ATOM3List import *
from ATOM3String import *
class ElementsXClass (ATOM3Type):
   def __init__(self):
      ATOM3Type.__init__(self)
      self.Elements= None
      self.Class= None

   def createComponents(self):
      if not self.Elements:
         self.Elements=ATOM3List([ 1, 1, 1, 0],ATOM3String)
         lcobj0=[]
         self.Elements.setValue(lcobj0)
      if not self.Class:
         self.Class=ATOM3String('')

   def show(self, parent, parentWindowInfo=None):
      self.createComponents()
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Elements').grid(row=0,column=0,sticky=W)
      self.Elements.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      Label(self.containerFrame, text='Class').grid(row=1,column=0,sticky=W)
      self.Class.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      return self.containerFrame

   def toString(self):
      self.createComponents()
      return  self.Elements.toString()+' '+ self.Class.toString()
   def getValue(self):
      self.createComponents()
      return (self.Elements.getValue(),self.Class.getValue(),)

   def setValue(self, value):
      self.createComponents()
      if value == None:
         self.Elements.setNone()
         self.Class.setNone()
      else:
         self.Elements.setValue(value[0])
         self.Class.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      file.write(indent+objName+'= ElementsXClass()\n')
      self.Elements.writeConstructor2File(file, indent, objName+'.Elements', depth, generatingCode)
      self.Class.writeConstructor2File(file, indent, objName+'.Class', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.Elements.writeValue2File(file, indent, objName+'.Elements', depth, generatingCode)
      self.Class.writeValue2File(file, indent, objName+'.Class', depth, generatingCode)

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = ElementsXClass()
     if self.Elements: cloneObject.Elements = self.Elements.clone()
     if self.Class: cloneObject.Class = self.Class.clone()
     return cloneObject
   def destroy(self):
     "Destroys (i.e. updates) each field"
     cloneObject = ElementsXClass()
     if self.Elements: self.Elements.destroy()
     if self.Class: self.Class.destroy()
     return cloneObject
   def invalid(self):
     "checks whether the entity is valid or not"
     inval = 0
     if self.Elements: inval = inval or self.Elements.invalid()
     if self.Class: inval = inval or self.Class.invalid()
     return inval

