from Tkinter import *
from ATOM3Type import *
from ASG_Method_SC import ASG_Method_SC
from ASG_Method_CBD import ASG_Method_CBD
class Method_SCUMethod_CBD (ATOM3Type):
   def __init__(self):
     ATOM3Type.__init__(self)
     self.optMenu = None
     self.selected= None
     self.lastSelected= None
     self.StateChart= None
     self.CBD4OOCSMP= None

   def createComponents(self):
     if not self.StateChart:
        from StateChart import *
        self.StateChart=ASG_Method_SC()
     if not self.CBD4OOCSMP:
        from CBD4OOCSMP import *
        self.CBD4OOCSMP=ASG_Method_CBD()

   def show(self, parent, parentWindowInfo=None):
     ATOM3Type.show(self, parent, parentWindowInfo)
     self.createComponents()
     self.showParent = parent
     self.parentWindowInfo = parentWindowInfo
     self.selected = StringVar()
     if not self.lastSelected:
        self.selected.set('StateChart')
     else:
        self.selected.set(self.lastSelected)
     self.label = None
     self.widget = None
     self.containerFrame = Frame(parent)
     Label(self.containerFrame, text='Select Attribute').grid(row=0,column=0,sticky=W)
     self.optMenu = OptionMenu(self.containerFrame, self.selected,'StateChart','CBD4OOCSMP')
     self.selected.trace_variable( 'w', self.valueChanged)
     self.optMenu.grid(row=0,column=1,sticky=W)
     if self.lastSelected == 'StateChart':
           self.destroyAllBut(self.StateChart)
           self.showStateChart(self.showParent, self.parentWindowInfo)
     if self.lastSelected == 'CBD4OOCSMP':
           self.destroyAllBut(self.CBD4OOCSMP)
           self.showCBD4OOCSMP(self.showParent, self.parentWindowInfo)
     return self.containerFrame

   def valueChanged(self, param1, param2, param3):
     value = self.selected.get()
     if value == 'StateChart':
        if self.lastSelected != 'StateChart':
           self.destroyAllBut(self.StateChart)
           self.showStateChart(self.showParent, self.parentWindowInfo)
     if value == 'CBD4OOCSMP':
        if self.lastSelected != 'CBD4OOCSMP':
           self.destroyAllBut(self.CBD4OOCSMP)
           self.showCBD4OOCSMP(self.showParent, self.parentWindowInfo)
   def destroyAllBut(self, survivor):
     if survivor != self.StateChart:
        self.StateChart.destroy()
     if survivor != self.CBD4OOCSMP:
        self.CBD4OOCSMP.destroy()

   def showStateChart(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='StateChart')
     self.label.grid(row=1,column=0,sticky=W)
     self.widget = self.StateChart.show(self.containerFrame, self.parentWindowInfo)
     self.widget.grid(row=1,column=1,sticky=W)
     self.lastSelected = 'StateChart'

   def showCBD4OOCSMP(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='CBD4OOCSMP')
     self.label.grid(row=1,column=0,sticky=W)
     self.widget = self.CBD4OOCSMP.show(self.containerFrame, self.parentWindowInfo)
     self.widget.grid(row=1,column=1,sticky=W)
     self.lastSelected = 'CBD4OOCSMP'

   def toString(self, fils = 25, cols = 5):
     self.createComponents()
     if self.selected:
        value = self.selected.get()
     elif self.lastSelected:
        value = self.lastSelected
     else:
        value = None
     if value == 'StateChart':
        return self.StateChart.toString(fils, cols)
     elif value == 'CBD4OOCSMP':
        return self.CBD4OOCSMP.toString(fils, cols)
     return ''

   def getValue(self):
     self.createComponents()
     return (self.StateChart.getValue(),self.CBD4OOCSMP.getValue(),)

   def setValue(self, value):
     self.createComponents()
     if value == None:
        self.StateChart.setNone()
        self.CBD4OOCSMP.setNone()
     else:
        self.StateChart.setValue(value[0])
        self.CBD4OOCSMP.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
     self.createComponents()
     file.write(indent+objName+'= Method_SCUMethod_CBD()\n')
     self.StateChart.writeConstructor2File(file, indent, objName+'.StateChart', depth, generatingCode)
     self.CBD4OOCSMP.writeConstructor2File(file, indent, objName+'.CBD4OOCSMP', depth, generatingCode)
     if self.lastSelected:
        file.write(indent+objName+'.lastSelected= "'+self.lastSelected+'"\n')

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
     self.createComponents()
     self.StateChart.writeValue2File(file, indent, objName+'.StateChart', depth, generatingCode)
     self.CBD4OOCSMP.writeValue2File(file, indent, objName+'.CBD4OOCSMP', depth, generatingCode)
     if self.lastSelected:
        file.write(indent+objName+'.lastSelected= "'+self.lastSelected+'"\n')
        print "lastSelected = ", self.lastSelected
        if self.lastSelected == "StateChart":
           file.write(indent+"from ASG_StateChart import ASG_StateChart\n")
           file.write(indent+objName+".StateChart = new ASG_StateChart()\n")

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = Method_SCUMethod_CBD()
     if self.StateChart: cloneObject.StateChart = self.StateChart.clone()
     if self.CBD4OOCSMP: cloneObject.CBD4OOCSMP = self.CBD4OOCSMP.clone()
     cloneObject.lastSelected = self.lastSelected
     return cloneObject
   def copy(self, other):
     "Copies the content of other into itself"
     ATOM3Type.copy(self, other)
     self.StateChart = other.StateChart
     self.CBD4OOCSMP = other.CBD4OOCSMP
     ASGNode.copy(self,other)
   def destroy(self):
     "Destroys (i.e. updates) each field"
     if self.StateChart: self.StateChart.destroy()
     if self.CBD4OOCSMP: self.CBD4OOCSMP.destroy()


   def invalid(self):
     "checks whether the entity is valid or not"
     inval = 0
     if self.StateChart: inval = inval or self.StateChart.invalid()
     if self.CBD4OOCSMP: inval = inval or self.CBD4OOCSMP.invalid()
     return inval

