from Tkinter import *
from ATOM3Type import *
from ATOM3Enum import *
from OOCSMPObjectType import *
from OOCSMPCollection import *
class OOCSMPbasicTypeUObjectUCollection (ATOM3Type):
   def __init__(self):
     ATOM3Type.__init__(self)
     self.optMenu = None
     self.selected= None
     self.lastSelected= None
     self.OOCSMPbasicType= None
     self.Object= None
     self.Collection= None

   def createComponents(self):
     if not self.OOCSMPbasicType:
        self.OOCSMPbasicType=ATOM3Enum(['Scalar', 'Vector', 'Matrix', 'Name', 'Icon', 'VRMLobject'], 0, 0)
     if not self.Object:
        self.Object= ClassXParameters()
        self.Object.Class=ATOM3String('')
        self.Object.Parameters=ATOM3List([ 1, 1, 1, 0],ATOM3String)
        lcobj0=[]
        self.Object.Parameters.setValue(lcobj0)
     if not self.Collection:
        self.Collection= ElementsXClass()
        self.Collection.Elements=ATOM3List([ 1, 1, 1, 0],ATOM3String)
        lcobj0=[]
        self.Collection.Elements.setValue(lcobj0)
        self.Collection.Class=ATOM3String('')

   def show(self, parent, parentWindowInfo=None):
     ATOM3Type.show(self, parent, parentWindowInfo)
     self.createComponents()
     self.showParent = parent
     self.parentWindowInfo = parentWindowInfo
     self.selected = StringVar()
     if not self.lastSelected:
        self.selected.set('OOCSMPbasicType')
     else:
        self.selected.set(self.lastSelected)
     self.label = None
     self.widget = None
     self.containerFrame = Frame(parent)
     Label(self.containerFrame, text='Select Attribute').grid(row=0,column=0,sticky=W)
     self.optMenu = OptionMenu(self.containerFrame, self.selected,'OOCSMPbasicType','Object','Collection')
     self.selected.trace_variable( 'w', self.valueChanged)
     self.optMenu.grid(row=0,column=1,sticky=W)
     if self.lastSelected == 'OOCSMPbasicType':
           self.destroyAllBut(self.OOCSMPbasicType)
           self.showOOCSMPbasicType(self.showParent, self.parentWindowInfo)
     if self.lastSelected == 'Object':
           self.destroyAllBut(self.Object)
           self.showObject(self.showParent, self.parentWindowInfo)
     if self.lastSelected == 'Collection':
           self.destroyAllBut(self.Collection)
           self.showCollection(self.showParent, self.parentWindowInfo)
     return self.containerFrame

   def valueChanged(self, param1, param2, param3):
     value = self.selected.get()
     if value == 'OOCSMPbasicType':
        if self.lastSelected != 'OOCSMPbasicType':
           self.destroyAllBut(self.OOCSMPbasicType)
           self.showOOCSMPbasicType(self.showParent, self.parentWindowInfo)
     if value == 'Object':
        if self.lastSelected != 'Object':
           self.destroyAllBut(self.Object)
           self.showObject(self.showParent, self.parentWindowInfo)
     if value == 'Collection':
        if self.lastSelected != 'Collection':
           self.destroyAllBut(self.Collection)
           self.showCollection(self.showParent, self.parentWindowInfo)
   def destroyAllBut(self, survivor):
     if survivor != self.OOCSMPbasicType:
        self.OOCSMPbasicType.destroy()
     if survivor != self.Object:
        self.Object.destroy()
     if survivor != self.Collection:
        self.Collection.destroy()

   def showOOCSMPbasicType(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='OOCSMPbasicType')
     self.label.grid(row=1,column=0,sticky=W)
     self.widget = self.OOCSMPbasicType.show(self.containerFrame, self.parentWindowInfo)
     self.widget.grid(row=1,column=1,sticky=W)
     self.lastSelected = 'OOCSMPbasicType'

   def showObject(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='Object')
     self.label.grid(row=1,column=0,sticky=W)
     self.widget = self.Object.show(self.containerFrame, self.parentWindowInfo)
     self.widget.grid(row=1,column=1,sticky=W)
     self.lastSelected = 'Object'

   def showCollection(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='Collection')
     self.label.grid(row=1,column=0,sticky=W)
     self.widget = self.Collection.show(self.containerFrame, self.parentWindowInfo)
     self.widget.grid(row=1,column=1,sticky=W)
     self.lastSelected = 'Collection'

   def toString(self, fils = 25, cols = 5):
     self.createComponents()
     if self.selected:
        value = self.selected.get()
     elif self.lastSelected:
        value = self.lastSelected
     else:
        value = None
     if value == 'OOCSMPbasicType':
        return self.OOCSMPbasicType.toString(fils, cols)
     elif value == 'Object':
        return self.Object.toString(fils, cols)
     elif value == 'Collection':
        return self.Collection.toString(fils, cols)
     return ''

   def getValue(self):
     self.createComponents()
     return (self.OOCSMPbasicType.getValue(),self.Object.getValue(),self.Collection.getValue(),)

   def setValue(self, value):
     self.createComponents()
     if value == None:
        self.OOCSMPbasicType.setNone()
        self.Object.setNone()
        self.Collection.setNone()
     else:
        self.OOCSMPbasicType.setValue(value[0])
        self.Object.setValue(value[1])
        self.Collection.setValue(value[2])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
     self.createComponents()
     file.write(indent+objName+'= OOCSMPbasicTypeUObjectUCollection()\n')
     self.OOCSMPbasicType.writeConstructor2File(file, indent, objName+'.OOCSMPbasicType', depth, generatingCode)
     self.Object.writeConstructor2File(file, indent, objName+'.Object', depth, generatingCode)
     self.Collection.writeConstructor2File(file, indent, objName+'.Collection', depth, generatingCode)
     if self.lastSelected:
        file.write(indent+objName+'.lastSelected= "'+self.lastSelected+'"\n')

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
     self.createComponents()
     self.OOCSMPbasicType.writeValue2File(file, indent, objName+'.OOCSMPbasicType', depth, generatingCode)
     self.Object.writeValue2File(file, indent, objName+'.Object', depth, generatingCode)
     self.Collection.writeValue2File(file, indent, objName+'.Collection', depth, generatingCode)
     if self.lastSelected:
        file.write(indent+objName+'.lastSelected= "'+self.lastSelected+'"\n')

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = OOCSMPbasicTypeUObjectUCollection()
     if self.OOCSMPbasicType: cloneObject.OOCSMPbasicType = self.OOCSMPbasicType.clone()
     if self.Object: cloneObject.Object = self.Object.clone()
     if self.Collection: cloneObject.Collection = self.Collection.clone()
     cloneObject.lastSelected = self.lastSelected
     return cloneObject
   def copy(self, other):
     "Copies the content of other into itself"
     ATOM3Type.copy(self, other)
     self.OOCSMPbasicType = other.OOCSMPbasicType
     self.Object = other.Object
     self.Collection = other.Collection
     ASGNode.copy(self,other)
   def destroy(self):
     "Destroys (i.e. updates) each field"
     if self.OOCSMPbasicType: self.OOCSMPbasicType.destroy()
     if self.Object: self.Object.destroy()
     if self.Collection: self.Collection.destroy()


   def invalid(self):
     "checks whether the entity is valid or not"
     inval = 0
     if self.OOCSMPbasicType: inval = inval or self.OOCSMPbasicType.invalid()
     if self.Object: inval = inval or self.Object.invalid()
     if self.Collection: inval = inval or self.Collection.invalid()
     return inval

