from Tkinter import *
from ATOM3Type import *
from ASG_StateChart import ASG_StateChart
from ASG_CBD4OOCSMP import ASG_CBD4OOCSMP
class StateChartUCBD4OOCSMP (ATOM3Type):
   def __init__(self):
     ATOM3Type.__init__(self)
     self.optMenu = None
     self.selected= None
     self.lastSelected= None
     self.Method_SC= None
     self.Method_CBD= None

   def createComponents(self):
     if not self.Method_SC:
        from ASG_StateChart import ASG_StateChart
        self.Method_SC=ASG_StateChart()
     if not self.Method_CBD:
        from ASG_CBD4OOCSMP import ASG_CBD4OOCSMP
        self.Method_CBD=ASG_CBD4OOCSMP()

   def show(self, parent, parentWindowInfo=None):
     ATOM3Type.show(self, parent, parentWindowInfo)
     self.createComponents()
     self.showParent = parent
     self.parentWindowInfo = parentWindowInfo
     self.selected = StringVar()
     if not self.lastSelected:
        self.selected.set('Method_SC')
     else:
        self.selected.set(self.lastSelected)
     self.label = None
     self.widget = None
     self.containerFrame = Frame(parent)
     Label(self.containerFrame, text='Select Attribute').grid(row=0,column=0,sticky=W)
     self.optMenu = OptionMenu(self.containerFrame, self.selected,'Method_SC','Method_CBD')
     self.selected.trace_variable( 'w', self.valueChanged)
     self.optMenu.grid(row=0,column=1,sticky=W)
     if self.lastSelected == 'Method_SC':
           self.destroyAllBut(self.Method_SC)
           self.showMethod_SC(self.showParent, self.parentWindowInfo)
     if self.lastSelected == 'Method_CBD':
           self.destroyAllBut(self.Method_CBD)
           self.showMethod_CBD(self.showParent, self.parentWindowInfo)
     return self.containerFrame

   def valueChanged(self, param1, param2, param3):
     value = self.selected.get()
     if value == 'Method_SC':
        if self.lastSelected != 'Method_SC':
           self.destroyAllBut(self.Method_SC)
           self.showMethod_SC(self.showParent, self.parentWindowInfo)
     if value == 'Method_CBD':
        if self.lastSelected != 'Method_CBD':
           self.destroyAllBut(self.Method_CBD)
           self.showMethod_CBD(self.showParent, self.parentWindowInfo)
   def destroyAllBut(self, survivor):
     if survivor != self.Method_SC:
        self.Method_SC.destroy()
     if survivor != self.Method_CBD:
        self.Method_CBD.destroy()

   def showMethod_SC(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='Method_SC')
     self.label.grid(row=1,column=0,sticky=W)
     Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.Method_SC, ATOM3TypeDialog.OPEN)).grid(row=1,column=1,sticky=W)
     self.lastSelected = 'Method_SC'

   def showMethod_CBD(self, parent, parentWindow = None):
     if self.label and self.widget:
        self.label.grid_forget()
        self.widget.grid_forget()
     self.label = Label(self.containerFrame, text='Method_CBD')
     self.label.grid(row=1,column=0,sticky=W)
     Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.Method_CBD, ATOM3TypeDialog.OPEN)).grid(row=1,column=1,sticky=W)
     self.lastSelected = 'Method_CBD'

   def toString(self, fils = 25, cols = 5):
     self.createComponents()
     if self.selected:
        value = self.selected.get()
     elif self.lastSelected:
        value = self.lastSelected
     else:
        value = None
     if value == 'Method_SC':
        return self.Method_SC.toString(fils, cols)
     elif value == 'Method_CBD':
        return self.Method_CBD.toString(fils, cols)
     return ''

   def getValue(self):
     self.createComponents()
     return (self.Method_SC.getValue(),self.Method_CBD.getValue(),)

   def setValue(self, value):
     self.createComponents()
     if value == None:
        self.Method_SC.setNone()
        self.Method_CBD.setNone()
     else:
        self.Method_SC.setValue(value[0])
        self.Method_CBD.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
     self.createComponents()
     file.write(indent+objName+'= StateChartUCBD4OOCSMP()\n')
     if self.lastSelected:
        file.write(indent+objName+'.lastSelected= "'+self.lastSelected+'"\n')
        if self.lastSelected == "Method_SC":
           file.write(indent+"from ASG_StateChart import ASG_StateChart\n")
           file.write(indent+objName+".Method_SC = ASG_StateChart()\n")
           self.Method_SC.writeImports2File(file, indent)
           self.Method_SC.writeGraph2File(file, 1, 0, objName+".Method_SC", indent, genConstraints=0, depth = 2 )
           self.Method_SC.writeConstructor2File(file, indent, objName+'.Method_SC', depth, generatingCode)
        elif self.lastSelected == "Method_CBD":
           file.write(indent+"from ASG_CBD4OOCSMP import ASG_CBD4OOCSMP\n")
           file.write(indent+objName+".Method_CBD = ASG_CBD4OOCSMP()\n")
           self.Method_CBD.writeImports2File(file, indent)
           self.Method_CBD.writeGraph2File(file, 1, 0, objName+".Method_CBD", indent, 0, depth = 2)     
           self.Method_CBD.writeConstructor2File(file, indent, objName+'.Method_CBD', depth, generatingCode)
           

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
     self.createComponents()

     if self.lastSelected:
        file.write(indent+objName+'.lastSelected= "'+self.lastSelected+'"\n')
        if self.lastSelected == "Method_SC":
           file.write(indent+"from ASG_StateChart import ASG_StateChart\n")
           file.write(indent+objName+".Method_SC = ASG_StateChart()\n")
           self.Method_SC.writeImports2File(file, indent)
           self.Method_SC.writeGraph2File(file, 1, 0, objName+".Method_SC", indent, 0, depth = 2)
           self.Method_SC.writeValue2File(file, indent, objName+'.Method_SC', depth, generatingCode)
        elif self.lastSelected == "Method_CBD":
           file.write(indent+"from ASG_CBD4OOCSMP import ASG_CBD4OOCSMP\n")
           file.write(indent+objName+".Method_CBD = ASG_CBD4OOCSMP()\n")
           self.Method_CBD.writeImports2File(file, indent)
           self.Method_CBD.writeGraph2File(file, 1, 0, objName+".Method_CBD", indent, 0, depth = 2)
           self.Method_CBD.writeValue2File(file, indent, objName+'.Method_CBD', depth, generatingCode)           

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = StateChartUCBD4OOCSMP()
     if self.Method_SC: cloneObject.Method_SC = self.Method_SC.clone()
     if self.Method_CBD: cloneObject.Method_CBD = self.Method_CBD.clone()
     cloneObject.lastSelected = self.lastSelected
     return cloneObject
   def copy(self, other):
     "Copies the content of other into itself"
     ATOM3Type.copy(self, other)
     self.Method_SC = other.Method_SC
     self.Method_CBD = other.Method_CBD
     ASGNode.copy(self,other)
   def destroy(self):
     "Destroys (i.e. updates) each field"
     if self.Method_SC: self.Method_SC.destroy()
     if self.Method_CBD: self.Method_CBD.destroy()


   def invalid(self):
     "checks whether the entity is valid or not"
     inval = 0
     if self.Method_SC: inval = inval or self.Method_SC.invalid()
     if self.Method_CBD: inval = inval or self.Method_CBD.invalid()
     return inval

