# __Queue.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Float import *
from graph_Queue import *
class Queue(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Queue
      self.parent = parent
      self.Name=ATOM3String('')
      self.IAT=ATOM3Float(0.0)
      self.Tnext=ATOM3Float(0.0)
      self.generatedAttributes = {'Name': ('ATOM3String', ),
                                  'IAT': ('ATOM3Float', ),
                                  'Tnext': ('ATOM3Float', )      }
      self.realOrder = ['Name','IAT','Tnext']
      self.directEditing = [1,1,1]
   def clone(self):
      cloneObject = Queue( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


