from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Timer(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 64, 66
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([1.0, 1.0, 63.0, 65.0]), tags = self.tag, fill= 'pink', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_text(self.translate([33.0, 9.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'TIME', justify= 'left', width= '0', stipple= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_text(self.translate([33.0, 37.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'FINAL', justify= 'left', width= '0', stipple= '')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        if self.semanticObject: drawText = self.semanticObject.Time.toString(25,5)
        else: drawText = "<Time>"
        h = drawing.create_text(self.translate([31.0, 21.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'center', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["Time"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        if self.semanticObject: drawText = self.semanticObject.FinalTime.toString(25,5)
        else: drawText = "<FinalTime>"
        h = drawing.create_text(self.translate([30.0, 49.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'center', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["FinalTime"] = h
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Timer
