from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_sdIteration(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 126, 84
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"chgSize","self.semanticObject.", [], [])
        constObj.setValue(('chgSize', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'coords = self.gf1.getCoords()\012new_coords = (coords[0], coords[1], coords[0]+self.semanticObject.sizeX.getValue(), coords[1]+self.semanticObject.sizeY.getValue())\012self.gf1.setCoords(new_coords)\012self.gf0.setCoords((new_coords[0]+10, new_coords[3]-15))\012\012\012\012\012\012\012\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([2.0, 2.0, 125.0, 83.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_oval(self.translate([3.0, 3.0, 3.0, 3.0]), tags = (self.tag, "connector"), fill= 'red', outline= 'black', width= '1.0', stipple= '')
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.iteration.toString(25,5)
        else: drawText = "<iteration>"
        h = drawing.create_text(self.translate([5.0, 68.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'nw', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["iteration"] = h
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)

    def chgSize(self):
       coords = self.gf1.getCoords()
       new_coords = (coords[0], coords[1], coords[0]+self.semanticObject.sizeX.getValue(), coords[1]+self.semanticObject.sizeY.getValue())
       self.gf1.setCoords(new_coords)
       self.gf0.setCoords((new_coords[0]+10, new_coords[3]-15))
       
       
       
       
       
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.chgSize()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_sdIteration
