from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_sdMessage_1stSegment(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 156, 14
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"drawMessage","self.semanticObject.", [], [])
        constObj.setValue(('drawMessage', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'if self.semanticObject.isDestroyMessage.getValue()[1]==1: # destroy\012   self.gf0.setVisible(0)\012   self.gf2.setVisible(0)\012   self.gf3.setVisible(0)\012   self.gf4.setVisible(0)\012   self.gf5.setVisible(1)\012elif self.semanticObject.type.getValue()[1]==0: # message\012   self.gf0.setVisible(0)\012   self.gf2.setVisible(0)\012   self.gf3.setVisible(1)\012   self.gf4.setVisible(0)\012   self.gf5.setVisible(0)\012elif self.semanticObject.type.getValue()[1]==1: # condition\012   self.gf0.setVisible(1)\012   self.gf2.setVisible(1)\012   self.gf3.setVisible(1)\012   self.gf4.setVisible(1)\012   self.gf5.setVisible(0)\012\012\012\012\012\012\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_text(self.translate([2.0, 7.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= '[', justify= 'left', width= '0', stipple= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_text(self.translate([62.0, 6.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= ']', justify= 'left', width= '0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_text(self.translate([138.0, 7.0]), tags = self.tag, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', text= 'destroy', justify= 'left', width= '0', stipple= '')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        if self.semanticObject: drawText = self.semanticObject.condition.toString(25,5)
        else: drawText = "<condition>"
        h = drawing.create_text(self.translate([6.0, 1.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'nw', font= '{MS Sans Serif} 8', justify= 'left', width= '55', stipple= '')
        self.attr_display["condition"] = h
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        if self.semanticObject: drawText = self.semanticObject.message.toString(25,5)
        else: drawText = "<message>"
        h = drawing.create_text(self.translate([93.0, 7.0]), tags = self.tag, text = drawText, fill= 'black', anchor= 'center', font= '{MS Sans Serif} 8', justify= 'left', width= '0', stipple= '')
        self.attr_display["message"] = h
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)

    def drawMessage(self):
       if self.semanticObject.isDestroyMessage.getValue()[1]==1: # destroy
          self.gf0.setVisible(0)
          self.gf2.setVisible(0)
          self.gf3.setVisible(0)
          self.gf4.setVisible(0)
          self.gf5.setVisible(1)
       elif self.semanticObject.type.getValue()[1]==0: # message
          self.gf0.setVisible(0)
          self.gf2.setVisible(0)
          self.gf3.setVisible(1)
          self.gf4.setVisible(0)
          self.gf5.setVisible(0)
       elif self.semanticObject.type.getValue()[1]==1: # condition
          self.gf0.setVisible(1)
          self.gf2.setVisible(1)
          self.gf3.setVisible(1)
          self.gf4.setVisible(1)
          self.gf5.setVisible(0)
       
       
       
       
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.drawMessage()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_sdMessage_1stSegment
