from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_sdMessage_2ndLink(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 21, 56
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"changeDestroyMessage","self.semanticObject.", [], [])
        constObj.setValue(('changeDestroyMessage', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), "if self.semanticObject.isDestroyMessage.getValue()[1]==0: # it's not a destroy message\012   self.gf2.setVisible(0)\012   self.gf4.setVisible(0)\012else:  # it's a destroy message\012   self.gf2.setVisible(1)\012   self.gf4.setVisible(1)\012\012\012\012\012"))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_line(self.translate([4.0, 3.0, 16.0, 53.0, 16.0, 53.0]), tags = self.tag, fill= 'red', joinstyle= 'round', smooth= 0, capstyle= 'butt', arrow= 'none', arrowshape= '8 10 3', splinesteps= '12', width= '2.0', stipple= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_line(self.translate([17.0, 4.0, 3.0, 53.0]), tags = self.tag, fill= 'red', joinstyle= 'round', smooth= 0, capstyle= 'butt', arrow= 'none', arrowshape= '8 10 3', splinesteps= '12', width= '2.0', stipple= '')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)

    def changeDestroyMessage(self):
       if self.semanticObject.isDestroyMessage.getValue()[1]==0: # it's not a destroy message
          self.gf2.setVisible(0)
          self.gf4.setVisible(0)
       else:  # it's a destroy message
          self.gf2.setVisible(1)
          self.gf4.setVisible(1)
       
       
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.changeDestroyMessage()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_sdMessage_2ndLink
