# __sdActivationBox.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Port import *
from graph_sdActivationBox import *
class sdActivationBox(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_sdActivationBox
      self.parent = parent
      self.lifeLineConnector = []
      self.generatedAttributes = {      }
      self.realOrder = []
      self.directEditing = [1]
   def clone(self):
      cloneObject = sdActivationBox( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if actionID == self.SAVE:
         res = self.outgoingMessages(params)
         if res: return res
      if actionID == self.SAVE:
         res = self.incomingReturnMessages(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def outgoingMessages(self, params):
      # Slo se permite el envo de un mensaje o de varias condiciones.
      # Esa la nica forma de especificar el orden en que se producen los mensajes
      # en la linea de vida de un objeto.
      # Una ActivationBox slo puede enviar un mensaje de retorno.
      
      if len(self.out_connections_)>1:
         # we count the outgoing expressions, conditions and return messages
         numMessages   = 0
         numConditions = 0
         numReturns = 0
         for msg in self.out_connections_: 
            if   msg.getClass()=="sdMessage" and msg.type.getValue()[1]==0: numMessages = numMessages+1
            elif msg.getClass()=="sdMessageCreate": numMessages = numMessages+1
            elif msg.getClass()=="sdMessage" and msg.type.getValue()[1]==1: numConditions = numConditions+1
            elif msg.getClass()=="sdReturnMessage": numReturns = numReturns+1
         if (numConditions>0 and numMessages>0): return("Both expressions and conditions aren't allowed from an Activation Box",self)
         if (numMessages>1): return("Only one message allowed from an Activation Box",self)
         if (numReturns>1): return("Only one return message allowed from an Activation Box",self)
      
      
      
      
      
      
      
      
      
      

   def incomingReturnMessages(self, params):
      # There must be the same number of incoming return messages and outgoing messages
      
      # 1. we count how much outgoing messages have the activation box
      numMessages = 0
      for outc in self.out_connections_:
         if outc.getClass()=="sdMessage": numMessages = numMessages+1
      
      # 2. we count how much incoming return messages have the activation box
      numReturns = 0
      for inc in self.in_connections_:
         if inc.getClass()=="sdReturnMessage": numReturns = numReturns+1
      
      # 3. the number of outgoing messages and incoming return have to be the same
      if (numMessages<numReturns): return("Too many incoming return messages in the Activation Box",self)
      elif (numMessages>numReturns): return("Too few incoming return messages in the Activation Box",self)
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      



