# __sdBoxInIteration.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from graph_sdBoxInIteration import *
class sdBoxInIteration(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_sdBoxInIteration
      self.parent = parent
      self.generatedAttributes = {      }
      self.realOrder = []
      self.directEditing = []
   def clone(self):
      cloneObject = sdBoxInIteration( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.CONNECT:
         res = self.moveIteration(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def moveIteration(self, params):
      if self.in_connections_ == []: return
      iteration = self.in_connections_[0]
      minX, minY = iteration.graphObject_.x, iteration.graphObject_.y
      maxX, maxY = minX+iteration.sizeX.getValue(), minY+iteration.sizeY.getValue()
      
      if self.out_connections_ == []: return
      box = self.out_connections_[0]
      bminx, bminy = box.graphObject_.x, box.graphObject_.y
      bmaxx, bmaxy = bminx+box.graphObject_.sizeX, bminy+box.graphObject_.sizeY
      
      if bminx < minX:
         iteration.graphObject_.Move(bminx-minX, 0)
      if bminy < minY:
         iteration.graphObject_.Move(0, bminy-minY)
      
      coords = iteration.graphObject_.gf1.getCoords()			# get coordinates of rectangle to resize it
      
      if bmaxx > maxX:  coords[2] = bmaxx
      else: coords[2] = maxX
      
      if bmaxy > maxY:  coords[3] = bmaxy
      else: coords[3] = maxY
      
      iteration.sizeX.setValue(int(coords[2]-coords[0]))
      iteration.sizeY.setValue(int(coords[3]-coords[1]))
      
      iteration.graphObject_.chgSize()
      
      
      



