# __sdLifeLine.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Boolean import *
from graph_sdLifeLine import *
class sdLifeLine(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_sdLifeLine
      self.parent = parent
      self.join=ATOM3Boolean()
      self.join.setValue((None, 0))
      self.join.config = 0
      self.generatedAttributes = {'join': ('ATOM3Boolean', )      }
      self.realOrder = ['join']
      self.directEditing = [1]
   def clone(self):
      cloneObject = sdLifeLine( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.joinActivationBoxes(params)
         if res: return res
      if actionID == self.CONNECT:
         res = self.differentSourceTarget(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def joinActivationBoxes(self, params):
      # if "join" attribute is true, move the activation boxes to join them
      
      if self.join.getValue()[1]==1:
      
         if self.in_connections_ == []: return
         if self.out_connections_ == []: return
      
         activationBox1 = self.in_connections_[0]
         activationBox2 = self.out_connections_[0]
      
         minX1,minY1 = activationBox1.graphObject_.x,activationBox1.graphObject_.y
         minX2,minY2 = activationBox2.graphObject_.x,activationBox2.graphObject_.y
         selfx,selfy = self.graphObject_.x,self.graphObject_.y
      
         if minX1<minX2: 
            activationBox2.graphObject_.Move(-minX2+minX1,0)
            if minX1<selfx: self.graphObject_.Move(minX1-selfx+activationBox1.graphObject_.sizeX/2,0)
            else: self.graphObject_.Move(selfx-minX1+activationBox1.graphObject_.sizeX/2,0)
      
         else: 
            activationBox1.graphObject_.Move(-minX1+minX2,0)
            if minX2<selfx: self.graphObject_.Move(minX2-selfx+activationBox1.graphObject_.sizeX/2,0)
            else: self.graphObject_.Move(selfx-minX2+activationBox1.graphObject_.sizeX/2,0)
      
         if minY1<minY2: 
            activationBox2.graphObject_.Move(0,-minY2+minY1+activationBox1.graphObject_.sizeY)
            if minY1<selfy: self.graphObject_.Move(0,minY1-selfy+activationBox1.graphObject_.sizeY)
            else: self.graphObject_.Move(0,selfy-minY1+activationBox1.graphObject_.sizeY)
      
         else: 
            activationBox1.graphObject_.Move(0,-minY1+minY2+activationBox1.graphObject_.sizeY)
            if minY2<selfy: self.graphObject_.Move(0,minY2-selfy+activationBox1.graphObject_.sizeY)
            else: self.graphObject_.Move(0,selfy-minY2+activationBox1.graphObject_.sizeY)
        
         
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

   def differentSourceTarget(self, params):
      # source and target activation boxes can't be the same
      
      if self.in_connections_ == []: return
      if self.out_connections_ == []: return
      if self.in_connections_[0] == self.out_connections_[0]: return("Source box and Target box can't be the same",self)
      



