import tkFont

from graphEntity     import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_SourceFile(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 165, 72
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []
        self.imageDict = self.getImageDict()

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([2.0, 17.0, 2.0, 17.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([2.0, 37.0, 2.0, 37.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([2.0, 57.0, 2.0, 57.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([122.0, 2.0, 122.0, 2.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([82.0, 2.0, 82.0, 2.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([42.0, 2.0, 42.0, 2.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_polygon(self.translate([2.0, 2.0, 162.0, 2.0, 162.0, 70.000000000000114, 2.0, 70.000000000000114]), tags = self.tag, stipple = '', width = 1, outline = 'black', fill = 'white', smooth = 'False', splinesteps =  '12')
        self.gf29 = GraphicalForm(drawing, h, "gf29")
        self.graphForms.append(self.gf29)

        h = drawing.create_line(self.translate([2.0, 27.0, 162.0, 27.0]), tags = self.tag, stipple = '', width = 1, fill = 'black', smooth = 'False', splinesteps =  '12', capstyle = 'butt', joinstyle = 'round', arrow = 'none', arrowshape = (15,15,3))
        self.gf30 = GraphicalForm(drawing, h, "gf30")
        self.graphForms.append(self.gf30)

        h = drawing.create_line(self.translate([3.0, 30.0, 163.0, 30.0]), tags = self.tag, stipple = '', width = 1, fill = 'black', smooth = 'False', splinesteps =  '12', capstyle = 'butt', joinstyle = 'round', arrow = 'none', arrowshape = (15,15,3))
        self.gf32 = GraphicalForm(drawing, h, "gf32")
        self.graphForms.append(self.gf32)

        h = drawing.create_line(self.translate([3.0, 33.0, 163.0, 33.0]), tags = self.tag, stipple = '', width = 1, fill = 'black', smooth = 'False', splinesteps =  '12', capstyle = 'butt', joinstyle = 'round', arrow = 'none', arrowshape = (15,15,3))
        self.gf33 = GraphicalForm(drawing, h, "gf33")
        self.graphForms.append(self.gf33)

        h = drawing.create_oval(self.translate([162.0, 17.0, 162.0, 17.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([162.0, 37.0, 162.0, 37.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([162.0, 57.0, 162.0, 57.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([122.0, 70.0, 122.0, 70.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([82.0, 70.0, 82.0, 70.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        h = drawing.create_oval(self.translate([42.0, 70.0, 42.0, 70.0]), tags = (self.tag, 'connector'), outline = '', fill = '' )
        self.connectors.append( h )

        if self.semanticObject: drawText = self.semanticObject.name.toString(80,10)
        else: drawText = "<name>"
        font = tkFont.Font( family='Helvetica', size=12, weight='normal', slant='roman', underline=0)
        h = drawing.create_text(self.translate([77.0, 5.0]), tags = self.tag, font=font, fill = 'black', anchor = 'n', text = drawText, width = '0', justify= 'left', stipple='' )
        self.attr_display["name"] = h
        self.gf34 = GraphicalForm(drawing, h, 'gf34', fontObject=font)
        self.graphForms.append(self.gf34)

        if self.semanticObject: drawText = self.semanticObject.description.toString(80,10)
        else: drawText = "<description>"
        font = tkFont.Font( family='Helvetica', size=12, weight='normal', slant='roman', underline=0)
        h = drawing.create_text(self.translate([4.0, 37.0]), tags = self.tag, font=font, fill = 'black', anchor = 'nw', text = drawText, width = '0', justify= 'left', stipple='' )
        self.attr_display["description"] = h
        self.gf35 = GraphicalForm(drawing, h, 'gf35', fontObject=font)
        self.graphForms.append(self.gf35)



    def postCondition( self, actionID, * params):
        return None

    def preCondition( self, actionID, * params):
        return None

    def getImageDict( self ):
        imageDict = dict()

        return imageDict

new_class = graph_SourceFile
