# __Orthogonal.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from graph_Orthogonal import *
class Orthogonal(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Orthogonal
      self.parent = parent
      self.Name=ATOM3String('ortho')
      self.keyword_= self.Name
      self.generatedAttributes = {'Name': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Name').grid(row=0,column=0,sticky=W)
      self.Name.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Name', 0, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 1)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Name.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Name.getValue(),)

   def setValue(self, value):
      self.Name.setValue(value[0])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Name.writeConstructor2File(file, indent, objName+'.Name', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Name.writeValue2File(file, indent, objName+'.Name', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Name.invalid() 

   def clone(self):
      cloneObject = Orthogonal( self.parent )
      cloneObject.Name = self.Name.clone()
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Name = other.Name
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Name.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if actionID == self.DRAG:
         res = self.moveInnerBlobsDRAG(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.MOVE:
         res = self.moveInnerBlobsMOVE(params)
         if res: return res
      if actionID == self.CREATE:
         res = self.initializeObject(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def moveInnerBlobsDRAG(self, params):
      #
      # Store my position before moving.
      #
      self.initdrag = (self.graphObject_.x, self.graphObject_.y)
      
      
      
      
      
      

   def moveInnerBlobsMOVE(self, params):
      #
      # Move the inner blobs!
      #
      delta = (self.graphObject_.x - self.initdrag[0], self.graphObject_.y - self.initdrag[1])
      connections = []
      for ib in self.innerBlobs:
         ib.graphObject_.Move(delta[0], delta[1])
         for conn in ib.in_connections_+ib.out_connections_:
            if not conn.graphObject_ in connections: connections.append(conn.graphObject_)
      for conn in connections:
         conn.selectedHandler = conn.ALL_SELECTED
         conn.Move(delta[0], delta[1])
      self.initdrag = (self.initdrag[0]+delta[0], self.initdrag[1]+delta[1])
      
      
      
      
      
      
      
      
      
      

   def initializeObject(self, params):
      #
      # Create an inital list of inner blobs.
      #
      self.innerBlobs = []
      return None
      
      
      
      



