from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Blob(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 58, 60
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([3.0, 26.0, 3.0, 26.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([3.0, 56.0, 3.0, 56.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([3.0, 3.0, 3.0, 3.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([29.0, 3.0, 29.0, 3.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([27.0, 57.0, 27.0, 57.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([55.0, 57.0, 55.0, 57.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([55.0, 27.0, 55.0, 27.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([54.0, 5.0, 54.0, 5.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_rectangle(self.translate([3.0, 4.0, 54.0, 57.0]), tags = self.tag, fill = "", outline = "black")
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        if self.semanticObject: drawText = self.semanticObject.Name.toString(25,5)
        else: drawText = "<Name>"
        h = drawing.create_text(self.translate([24.0, 10.0]), tags = self.tag, text = drawText, fill = "blue")

        self.attr_display["Name"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Blob
