from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Hyperedge_Center(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 119, 35
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"invisibleBar","self.semanticObject.", [], [])
        constObj.setValue(('invisibleBar', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), '#\012# Make the bar invisible if there are no boradcats events.\012#\012bevts = self.semanticObject.Broadcast_Event.getValue()\012if bevts == []:\012  self.gf3.setVisible(0)\012else:\012  self.gf3.setVisible(1)\012\012\012\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_text(self.translate([3.0, 21.0]), tags = self.tag, fill= 'black', anchor= 'center', font= 'Helvetica -12', text= '/', justify= 'left', width= '0', stipple= '')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        if self.semanticObject: drawText = self.semanticObject.Broadcast_Event.toString(25,5)
        else: drawText = "<Broadcast_Event>"
        h = drawing.create_text(self.translate([9.0, 21.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'nw', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Broadcast_Event"] = h
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        if self.semanticObject: drawText = self.semanticObject.Event.toString(25,5)
        else: drawText = "<Event>"
        h = drawing.create_text(self.translate([10.0, 7.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'w', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Event"] = h
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)

    def invisibleBar(self):
       #
       # Make the bar invisible if there are no boradcats events.
       #
       bevts = self.semanticObject.Broadcast_Event.getValue()
       if bevts == []:
         self.gf3.setVisible(0)
       else:
         self.gf3.setVisible(1)
       
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.invisibleBar()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Hyperedge_Center
