# __TPPN_TimedPlace.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Integer import *
from graph_TPPN_TimedPlace import *
class TPPN_TimedPlace(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_TPPN_TimedPlace
      self.parent = parent
      self.name=ATOM3String('Place')
      self.keyword_= self.name
      self.timeAtPlace=ATOM3Integer(0)
      self.availableTokens=ATOM3Integer(0)
      self.delayedTokens=ATOM3Integer(0)
      self.generatedAttributes = {'name': ('ATOM3String', ),
                                  'timeAtPlace': ('ATOM3Integer', ),
                                  'availableTokens': ('ATOM3Integer', ),
                                  'delayedTokens': ('ATOM3Integer', )      }
      self.realOrder = ['name','timeAtPlace','availableTokens','delayedTokens']
      self.directEditing = [1,1,1,1]
   def clone(self):
      cloneObject = TPPN_TimedPlace( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.name
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.validTimeAtPlace(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.validAvailableTokens(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def validTimeAtPlace(self, params):
      time = self.timeAtPlace.getValue()
      if time < 0:
      	return ("Time at place must be >=0", self)
      return None
      
      
      
      

   def validAvailableTokens(self, params):
      ntokens = self.availableTokens.getValue()
      if ntokens < 0:
      	return ("Initial number of tokens must be >=0", self)
      return None
      
      
      
      
      



