from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_TPPN_TimedPlace(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 137, 72
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_oval(self.translate([27.0, 6.0, 92.0, 69.0]), tags = self.tag, stipple= '', width= '2.0', outline= 'black', fill= 'lightYellow')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_line(self.translate([60.0, 6.0, 60.0, 68.0]), tags = self.tag, stipple= '', width= '2.0', splinesteps= '1', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 0, joinstyle= 'round', fill= 'darkGreen')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_oval(self.translate([33.0, 18.0, 56.0, 41.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'white')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_oval(self.translate([64.0, 18.0, 87.0, 41.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'black')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_rectangle(self.translate([46.0, 50.0, 75.0, 69.0]), tags = self.tag, stipple= '', width= '2.0', outline= 'black', fill= 'yellow')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_oval(self.translate([60.0, 6.0, 60.0, 6.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([91.0, 37.0, 91.0, 37.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([59.0, 69.0, 59.0, 69.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([27.0, 38.0, 27.0, 38.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.availableTokens.toString(25,5)
        else: drawText = "<availableTokens>"
        h = drawing.create_text(self.translate([76.0, 29.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'lightGray', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'center')
        self.attr_display["availableTokens"] = h
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        if self.semanticObject: drawText = self.semanticObject.name.toString(25,5)
        else: drawText = "<name>"
        h = drawing.create_text(self.translate([112.0, 8.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'black', font= '{MS Sans Serif} 10', anchor= 'center', justify= 'left')
        self.attr_display["name"] = h
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        if self.semanticObject: drawText = self.semanticObject.timeAtPlace.toString(25,5)
        else: drawText = "<timeAtPlace>"
        h = drawing.create_text(self.translate([61.0, 58.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'black', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'center')
        self.attr_display["timeAtPlace"] = h
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        if self.semanticObject: drawText = self.semanticObject.delayedTokens.toString(25,5)
        else: drawText = "<delayedTokens>"
        h = drawing.create_text(self.translate([43.0, 29.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'black', font= '{MS Sans Serif} 8', anchor= 'center', justify= 'center')
        self.attr_display["delayedTokens"] = h
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_TPPN_TimedPlace
