#########
#
# Clase utilizada para almacenar los eventos ordenados por tiempo
#
#########
class PriorityQeue:
    "Cola de prioridad basada en una lista y su metodo sort"
    def __init__(self, elems=None):
        self.qeue = []
        if elems is not None:
            self.qeue = elems
            self.qeue.sort()
            
    def extract(self):
        " Extraer el primer elemnto de la cola de prioridad"
        if len(self.qeue) <= 0:
            return None
        return self.qeue.pop(0)

    def peek(self):
        " Obtener sin extraer el primer elemnto de la cola de prioridad"
        if len(self.qeue) <= 0:
            return None
        return self.qeue[0]

    def isEmpty(self):
        " Comprobar si la cola esta vacia"
        if len(self.qeue) <= 0:
            return 1
        return None

    def insert(self, elem):
        " Insercion de un elemento en la cola de prioridad"
        i = 0
        while i<len(self.qeue) and self.qeue[i] < elem: i+=1
        self.qeue.insert(i, elem)

    def dump(self):
        " Metodo que muestra el contenido de la cola"
        print "Contenido de la cola:"
        if len(self.qeue) <= 0:
            print "\t < Cola vacia >"
            return
        print "\t Tiempo\t Place \t Tokens"
        f = (lambda t: "\t  %s \t  %s \t  %s" % (t[0], t[1], t[2]))
        filas = [f(elem) for elem in self.qeue]
        print "\n".join(["%s" % (fila) for fila in filas])

