"""
KeyBinds.py

This module recieves direct calls from the AToM3 kernel mouse&key bindings.
It interprets each mouse & key press as an action/s and sends that action to the 
UI statechart that then decides what behaviour will occur, depending on what
previous actions were taken, and where the mouse is, etc...
 
Created June 15, 2004 by Denis Dube
"""

import Tkinter



def createBindings(self, canvas, tkRoot):
  """ Binds up the cavnas and the tkRoot window """
  
  #------------------------- Mouse 1, Left Button  ---------------------------
 
#  def handler(event):
#    self.UI_Statechart.event("Fresh Selection", event)  
#    self.UI_Statechart.event("Select Point", event)
#    self.UI_Statechart.event("Drop Point", event)
#    self.UI_Statechart.event("Start Drag", event)     
#    self.popupMenuCreator.popupRemover()
#  canvas.bind("<ButtonPress-1>", handler)

  def buttonPress1Handler(self, event):
    self.UI_zone('<ButtonPress-1>', event)
    self.popupMenuCreator.popupRemover()
  canvas.bind("<ButtonPress-1>", lambda event, s=self: 
                                     buttonPress1Handler(s, event))                                           

#  def handler(event):      
#    self.UI_Statechart.event("Finish Selection", event)
#    self.UI_Statechart.event("Finish Drag", event)
#    self.UI_Statechart.event("Finish Scale", event) 
#  canvas.bind("<Any-ButtonRelease-1>", handler)  

  canvas.bind("<Any-ButtonRelease-1>", lambda event, zone=self.UI_zone: 
                                        zone('<Any-ButtonRelease-1>', event))  
  
  #todo: WARNING: Drop point will not work with control modifier now
#  def handler(event):
#    self.UI_Statechart.event("Drop Point", event)
#    self.UI_Statechart.event("Create New Arrow", event)    
#  canvas.bind("<Control-ButtonPress-1>", handler)  
  canvas.bind("<Control-ButtonPress-1>", lambda event, zone=self.UI_zone: 
                                       zone('<Control-ButtonPress-1>', event)) 

#  canvas.bind("<Shift-ButtonPress-1>", lambda event, s=self: \
#                            s.UI_Statechart.event("Additive Selection", event)) 
  
  canvas.bind("<Shift-ButtonPress-1>", lambda event, zone=self.UI_zone: 
                                       zone('<Shift-ButtonPress-1>', event))   
                            
#  def handler(event):    
#    self.UI_Statechart.event("Edit Arrow", event)    
#  canvas.bind("<Double-ButtonPress-1>", handler)  
  
  canvas.bind("<Double-ButtonPress-1>", lambda event, zone=self.UI_zone: 
                                       zone('<Double-ButtonPress-1>', event))
                            
  #**** WARNING: Already bound on Linux desktop ( Window movement )
#  canvas.bind("<Alt-ButtonPress-1>", lambda event, s=self: \
#                            s.UI_Statechart.event("Negative Selection", event)) 
  canvas.bind("<Alt-ButtonPress-1>", lambda event, zone=self.UI_zone: 
                                       zone('<Alt-ButtonPress-1>', event))
  #**** 
  
  
  #------------------------ Mouse 2, Middle Button ---------------------------
  
  #todo: WARNING: Middle mouse will not start negative selection anymore
  #****  WARNING: Already bound on Windows desktop ( Scrollbar navigation )
#  canvas.bind("<ButtonPress-2>", lambda event, s=self: \
#                           s.UI_Statechart.event("Negative Selection", event))
#  canvas.bind("<Any-ButtonRelease-2>", lambda event, s=self: \
#                           s.UI_Statechart.event("Finish Selection", event)) 
  canvas.bind("<ButtonPress-2>", lambda event, zone=self.UI_zone: 
                                       zone('<ButtonPress-2>', event))
  canvas.bind("<Any-ButtonRelease-2>", lambda event, zone=self.UI_zone: 
                                       zone('<Any-ButtonRelease-2>', event))
  #**** 


  #------------------------ Mouse 3, Right Button ----------------------------
  
#  def handler(event):    
#    self.UI_Statechart.event("Popup Menu", event)
#    self.UI_Statechart.event("Done", event)
#    self.UI_Statechart.event("Rollback", event)
#    self.UI_Statechart.event("Reset Scale", event)
#  canvas.bind("<ButtonPress-3>", handler)  

  canvas.bind("<ButtonPress-3>", lambda event, zone=self.UI_zone: 
                                       zone('<ButtonPress-3>', event))
  
#  def handler(event):
#    self.UI_Statechart.event("Model Action", event)
#    self.popupMenuCreator.popupRemover()
#  canvas.bind("<Control-ButtonPress-3>", handler)  

  def buttonPress3Handler(self, event):
    self.UI_zone('<Control-ButtonPress-3>', event)
    self.popupMenuCreator.popupRemover()
  canvas.bind("<Control-ButtonPress-3>", lambda event, s=self: 
                                     buttonPress3Handler(s, event))       

  
#  def handler(event):
#    self.UI_Statechart.event("Edit Arrow", event)
#    self.popupMenuCreator.popupRemover()
#  canvas.bind("<Shift-ButtonPress-3>", handler)  

  def shiftButtonPress3Handler(self, event):
    self.UI_zone('<Shift-ButtonPress-3>', event)
    self.popupMenuCreator.popupRemover()
  canvas.bind("<Shift-ButtonPress-3>", lambda event, s=self: 
                                     shiftButtonPress3Handler(s, event))
  
  #-------------------------------- Mouse Motion -----------------------------
  
#  canvas.bind("<Any-Motion>", lambda event, s=self: \
#                                        s.UI_Statechart.event("Motion", event))

  canvas.bind("<Any-Motion>", lambda event, zone=self.UI_zone: 
                                       zone('<Any-Motion>', event))
    
  #------------------------------ Keyboard Binds -----------------------------
  
  # Since the canvas widget steadfastly refuses to be binded with mere keystrokes
  # the keys are binded to the Tk root window. Unfortunately, this means that
  # there is a position offset to the Canvas widget. The convert utility handles
  # this.
  conv = self.cb.convertRootToCanvasEvent  
    
  #--------------------------- Precise Movement ------------------------------
  
#  tkRoot.bind("<KeyPress-Up>", lambda event, s=self: \
#                              s.UI_Statechart.event("Move Up", conv(event)))
#  tkRoot.bind("<KeyPress-Down>", lambda event, s=self: \
#                             s.UI_Statechart.event("Move Down", conv(event)))
#  tkRoot.bind("<KeyPress-Left>", lambda event, s=self: \
#                             s.UI_Statechart.event("Move Left", conv(event)))
#  tkRoot.bind("<KeyPress-Right>", lambda event, s=self: \
#                            s.UI_Statechart.event("Move Right", conv(event)))

  tkRoot.bind("<KeyPress-Up>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Up>', conv(event)))
  tkRoot.bind("<KeyPress-Down>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Down>', conv(event)))
  tkRoot.bind("<KeyPress-Left>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Left>', conv(event)))
  tkRoot.bind("<KeyPress-Right>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Right>', conv(event)))
                                                    
  #------------------------------- Editing -----------------------------------

#  tkRoot.bind("<Control-KeyPress-a>", lambda event, s=self: \
#                           s.UI_Statechart.event("Select All", conv(event)))
#  tkRoot.bind("<Control-KeyPress-d>", lambda event, s=self: \
#                           s.UI_Statechart.event("Deselect All", conv(event)))
#
#  tkRoot.bind("<KeyPress-Delete>", lambda event, s=self: \
#                           s.UI_Statechart.event("Delete", conv(event)))
#  tkRoot.bind("<Shift-KeyPress-Delete>", lambda event, s=self: \
#                           s.UI_Statechart.event("EntityDelete", conv(event)))  
             
  tkRoot.bind("<Control-KeyPress-a>", lambda event, zone=self.UI_zone: 
                                       zone('<Control-KeyPress-a>', conv(event)))
  tkRoot.bind("<Control-KeyPress-d>", lambda event, zone=self.UI_zone: 
                                       zone('<Control-KeyPress-d>', conv(event)))
  tkRoot.bind("<KeyPress-Delete>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Delete>', conv(event)))
  tkRoot.bind("<Shift-KeyPress-Delete>", lambda event, zone=self.UI_zone: 
                                  zone('<Shift-KeyPress-Delete>', conv(event)))
  
  #todo: WARNING: key i no longer inserts points
#  tkRoot.bind("<KeyPress-Insert>", lambda event, s=self: \
#                           s.UI_Statechart.event("Insert Point", conv(event)))
#  tkRoot.bind("<KeyPress-i>", lambda event, s=self: \
#                           s.UI_Statechart.event("Insert Point", conv(event)))
#  
#  tkRoot.bind("<Control-KeyPress-Delete>", lambda event, s=self: \
#                          s.UI_Statechart.event("Clear Canvas", conv(event)))
#
#  tkRoot.bind("<KeyPress-s>", lambda event, s=self: \
#                          s.UI_Statechart.event("Smooth", conv(event)))

  tkRoot.bind("<KeyPress-Insert>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Insert>', conv(event)))
  tkRoot.bind("<KeyPress-i>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-i>', conv(event)))
  tkRoot.bind("<Control-KeyPress-Delete>", lambda event, zone=self.UI_zone: 
                               zone('<Control-KeyPress-Delete>', conv(event)))
  tkRoot.bind("<KeyPress-s>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-s>', conv(event)))
              
#  tkRoot.bind("<KeyPress-e>", lambda event, s=self: \
#                          s.UI_Statechart.event("Edit Overlap", conv(event)))
#       
#  tkRoot.bind("<KeyPress-r>", lambda event, s=self: \
#                          s.UI_Statechart.event("Scale Selection", conv(event)))
#                              
#    
#  tkRoot.bind("<KeyPress-d>", lambda event, s=self: \
#                          s.UI_Statechart.event("Drag Overlap", conv(event)))
    
  tkRoot.bind("<KeyPress-e>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-e>', conv(event)))
  tkRoot.bind("<KeyPress-r>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-r>', conv(event)))
  tkRoot.bind("<KeyPress-d>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-d>', conv(event)))

  #todo: WARNING: Return/Enter key no longer signals "DONE"
#  def handler(event):
#    self.UI_Statechart.event("Toggle Snap", conv(event))
#    self.UI_Statechart.event("Toggle Label Drag")
#    self.UI_Statechart.event("Move Label Toggle", conv(event))
#  tkRoot.bind("<KeyPress-space>", handler)  
#           
#  def handler(event):
#    self.UI_Statechart.event("Done")   
#  tkRoot.bind("<KeyPress-Return>", handler)      
  
  tkRoot.bind("<KeyPress-space>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-space>', conv(event)))
  tkRoot.bind("<KeyPress-Return>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-Return>', conv(event)))
  
  #--------------------------------- Menus -----------------------------------

#  tkRoot.bind("<KeyPress-l>", lambda event, s=self: \
#                              s.UI_Statechart.event("Layout Menu", conv(event)))
#  tkRoot.bind("<KeyPress-t>", lambda event, s=self: \
#                              s.UI_Statechart.event("Trans. Menu", conv(event)))
#  tkRoot.bind("<KeyPress-m>", lambda event, s=self: \
#                              s.UI_Statechart.event("Model Menu", conv(event)))
#  tkRoot.bind("<KeyPress-f>", lambda event, s=self: \
#                              s.UI_Statechart.event("File Menu", conv(event)))

  tkRoot.bind("<KeyPress-l>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-l>', conv(event)))
  tkRoot.bind("<KeyPress-t>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-t>', conv(event)))
  tkRoot.bind("<KeyPress-m>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-m>', conv(event)))
  tkRoot.bind("<KeyPress-f>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-f>', conv(event)))
                 
  #--------------------------------- File Ops --------------------------------
  
#  tkRoot.bind('<Alt-X>', lambda event, s=self: \
#                        s.UI_Statechart.event("Exit"))
#  tkRoot.bind('<Alt-x>', lambda event, s=self: \
#                        s.UI_Statechart.event("Exit")) 

  tkRoot.bind("<Alt-x>", lambda event, zone=self.UI_zone: 
                                       zone('<Alt-x>', conv(event)))
  
#  tkRoot.bind("<Control-KeyPress-o>", lambda event, s=self: \
#                                s.UI_Statechart.event("Open", conv(event)))
#  tkRoot.bind("<Control-KeyPress-s>", lambda event, s=self: \
#                                s.UI_Statechart.event("Save", conv(event)))
#  tkRoot.bind("<Alt-KeyPress-s>", lambda event, s=self: \
#                                s.UI_Statechart.event("Save As", conv(event)))

  tkRoot.bind("<Control-KeyPress-o>", lambda event, zone=self.UI_zone: 
                                       zone('<Control-KeyPress-o>', conv(event)))
  tkRoot.bind("<Control-KeyPress-s>", lambda event, zone=self.UI_zone: 
                                       zone('<Control-KeyPress-s>', conv(event)))
  tkRoot.bind("<Alt-KeyPress-s>", lambda event, zone=self.UI_zone: 
                                       zone('<Alt-KeyPress-s>', conv(event)))
   
                           
#  tkRoot.bind("<KeyPress-F1>", lambda event, s=self: \
#                     s.UI_Statechart.event("Options", conv(event)))
#  tkRoot.bind("<KeyPress-F2>", lambda event, s=self: \
#                     s.UI_Statechart.event("Show Console", conv(event))) 
#  tkRoot.bind("<KeyPress-F3>", lambda event, s=self: \
#                     s.UI_Statechart.event("Open Metamodel", conv(event)))
#  tkRoot.bind("<KeyPress-F4>", lambda event, s=self: \
#                     s.UI_Statechart.event("Close Metamodel", conv(event)))
#  tkRoot.bind("<KeyPress-F5>", lambda event, s=self: \
#                     s.UI_Statechart.event("Postscript", conv(event)))
#  tkRoot.bind("<KeyPress-F6>", lambda event, s=self: \
#                     s.UI_Statechart.event("Recent Model", conv(event)))
#  tkRoot.bind("<KeyPress-F7>", lambda event, s=self: \
#                     s.UI_Statechart.event("Recent Metamodel", conv(event)))
#  tkRoot.bind("<KeyPress-F8>", lambda event, s=self: \
#                     s.UI_Statechart.event("Source Paths", conv(event))) 
                     
  tkRoot.bind("<KeyPress-F1>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F1>', conv(event)))
  tkRoot.bind("<KeyPress-F2>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F2>', conv(event)))
  tkRoot.bind("<KeyPress-F3>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F3>', conv(event)))
  tkRoot.bind("<KeyPress-F4>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F4>', conv(event)))
  tkRoot.bind("<KeyPress-F5>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F5>', conv(event)))
  tkRoot.bind("<KeyPress-F6>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F6>', conv(event)))
  tkRoot.bind("<KeyPress-F7>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F7>', conv(event)))
  tkRoot.bind("<KeyPress-F8>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F8>', conv(event)))
                                         
  # -------------------------- Graphics / Layout -----------------------------
  
#  tkRoot.bind("<KeyPress-F9>", lambda event, s=self: \
#                        s.UI_Statechart.event("Smooth Default", conv(event))) 
#  tkRoot.bind("<KeyPress-F10>", lambda event, s=self: \
#                        s.UI_Statechart.event("Snap Grid Toggle", conv(event))) 
#  tkRoot.bind("<KeyPress-F11>", lambda event, s=self: \
#                        s.UI_Statechart.event("Spring Layout", conv(event)))
#  tkRoot.bind("<KeyPress-F12>", lambda event, s=self: \
#                        s.UI_Statechart.event("Arrow Optimizer", conv(event)))
#  tkRoot.bind("<Control-KeyPress-f>", lambda event, s=self: \
#                        s.UI_Statechart.event("Force Layout", conv(event)))
#  tkRoot.bind("<KeyPress-z>", lambda event, s=self: \
#                        s.UI_Statechart.event("Zoom Layout", conv(event)))

  tkRoot.bind("<KeyPress-F9>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F9>', conv(event)))
  tkRoot.bind("<KeyPress-F10>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F10>', conv(event)))
  tkRoot.bind("<KeyPress-F11>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F11>', conv(event)))
  tkRoot.bind("<KeyPress-F12>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-F12>', conv(event)))
  tkRoot.bind("<Control-KeyPress-f>", lambda event, zone=self.UI_zone: 
                                       zone('<Control-KeyPress-f>', conv(event)))
  tkRoot.bind("<KeyPress-z>", lambda event, zone=self.UI_zone: 
                                       zone('<KeyPress-z>', conv(event)))
                                                       
  # --------------------------- Copy & Paste ---------------------------------
  
#  tkRoot.bind("<Control-KeyPress-x>", lambda event, s=self: \
#                       s.UI_Statechart.event("Cut", conv(event)))
#  tkRoot.bind("<Control-KeyPress-c>", lambda event, s=self: \
#                       s.UI_Statechart.event("Copy", conv(event)))
#  tkRoot.bind("<Control-KeyPress-v>", lambda event, s=self: \
#                       s.UI_Statechart.event("Paste", conv(event)))
#  tkRoot.bind("<Alt-KeyPress-c>", lambda event, s=self: \
#                       s.UI_Statechart.event("Copy Attributes", conv(event)))
#  tkRoot.bind("<Alt-KeyPress-v>", lambda event, s=self: \
#                       s.UI_Statechart.event("Paste Attributes", conv(event)))
  
  tkRoot.bind("<Control-KeyPress-x>", lambda event, zone=self.UI_zone: 
                                   zone('<Control-KeyPress-x>', conv(event)))
  tkRoot.bind("<Control-KeyPress-c>", lambda event, zone=self.UI_zone: 
                                   zone('<Control-KeyPress-c>', conv(event)))
  tkRoot.bind("<Control-KeyPress-v>", lambda event, zone=self.UI_zone: 
                                   zone('<Control-KeyPress-v>', conv(event)))
  tkRoot.bind("<Alt-KeyPress-c>", lambda event, zone=self.UI_zone: 
                                      zone('<Alt-KeyPress-c>', conv(event)))
  tkRoot.bind("<Alt-KeyPress-v>", lambda event, zone=self.UI_zone: 
                                       zone('<Alt-KeyPress-v>', conv(event)))
  
  # ---------------------------- Undo & Redo ---------------------------------
  
#  tkRoot.bind("<Control-KeyPress-z>", lambda event, s=self: \
#                              s.UI_Statechart.event("Undo", conv(event)))
#  tkRoot.bind("<Control-KeyPress-y>", lambda event, s=self: \
#                              s.UI_Statechart.event("Redo", conv(event)))

  tkRoot.bind("<Control-KeyPress-z>", lambda event, zone=self.UI_zone: 
                                    zone('<Control-KeyPress-z>', conv(event)))
  tkRoot.bind("<Control-KeyPress-y>", lambda event, zone=self.UI_zone: 
                                    zone('<Control-KeyPress-y>', conv(event)))
  
  
  
  def rClicker(e):
    """ 
    Right click context menu for all Tk Entry widgets 
    Author: eltronic at juno.com
    Link: http://mail.python.org/pipermail/python-list/2004-March/214834.html
    """
  
    def rClick_Copy(e):
        e.widget.event_generate('<Control-c>')

    def rClick_Cut(e):
        e.widget.event_generate('<Control-x>')

    def rClick_Paste(e): 
        e.widget.event_generate('<Control-v>')

    e.widget.focus()
    nclst = [
        ('      ', None), 
        (' Cut', lambda e=e: rClick_Cut(e)), 
        (' Copy', lambda e=e: rClick_Copy(e)), 
        (' Paste', lambda e=e: rClick_Paste(e)), 
        ]
    
    rmenu = Tkinter.Menu(None, tearoff=0, takefocus=0)  
    for (txt, cmd) in nclst:
        if txt == ' ------ ':
            rmenu.add_separator()
        else:
            rmenu.add_command(label=txt, command=cmd)

    rmenu.entryconfigure(0, state = 'disabled')  
    rmenu.tk_popup(e.x_root-3, e.y_root+3, entry="0")
    
    return "break"
  
  for b in [ 'Entry', 'Listbox']:   
    self.parent.bind_class(b, sequence='<Button-3>', func=rClicker, add='')
    

  
  #------------------------------- DEBUGGING  ------------------------------  
  tkRoot.bind("<Control-KeyPress-1>", lambda event, s=self: onDebugKey1(s))
  tkRoot.bind("<Control-KeyPress-2>", lambda event, s=self: onDebugKey2(s))
  tkRoot.bind("<Control-KeyPress-3>", lambda event, s=self: onDebugKey3(s))
  tkRoot.bind("<Control-KeyPress-4>", lambda event, s=self: onDebugKey4(s))
  tkRoot.bind("<Control-KeyPress-5>", lambda event, s=self: onDebugKey5(s))
  tkRoot.bind("<Control-KeyPress-6>", lambda event, s=self: onDebugKey6(s))
 
        
      
def onDebugKey1(self):
  print 'onDebugKey1'
  from CircleLayout import applyLayout
  self.cb.buildSelectionObjectSet()
  applyLayout(self, selection=self.cb.getSelectionObjectSet())

def onDebugKey2(self):
  print 'onDebugKey2'
  from CircleLayout import applyLayout
  self.cb.buildSelectionObjectSet()
  applyLayout(self, settings=True, selection=self.cb.getSelectionObjectSet())
  
'''      
tuple = self.cb.getItemUnderCursor( self, event )
print tuple
if( tuple ):
  itemHandler,tag,obj = tuple
  print self.cb.getCanvas().coords( itemHandler ), "<-- coords"
  print "\n", tag, " --> showing connections"
  print obj.connections
  try:
    print obj.in_connections_
    print obj.out_connections_
  except:
    pass      
'''
  
def onDebugKey3(self):
  print 'onDebugKey3'
  #for nodeType in self.ASGroot.listNodes:
  
  from TreeLikeLayout import applyLayout
  self.cb.buildSelectionObjectSet()
  applyLayout(self, selection=self.cb.getSelectionObjectSet())

def onDebugKey4(self):
  print 'onDebugKey4'
  #for nodeType in self.ASGroot.listNodes:
  
  from TreeLikeLayout import applyLayout
  self.cb.buildSelectionObjectSet()
  applyLayout(self, settings=True, selection=self.cb.getSelectionObjectSet())
  
  
def onDebugKey5(self):
  print 'onDebugKey5'
  #for nodeType in self.ASGroot.listNodes:
  
  from HierarchicalLayout import applyLayout
  self.cb.buildSelectionObjectSet()
  applyLayout(self, selection=self.cb.getSelectionObjectSet())

def onDebugKey6(self):
  print 'onDebugKey6'
  #for nodeType in self.ASGroot.listNodes:
  
  from HierarchicalLayout import applyLayout
  self.cb.buildSelectionObjectSet()
  applyLayout(self, settings=True, selection=self.cb.getSelectionObjectSet())
      




  