"""
UI_Zone.py

Testing
"""

import sys


class UI_Zone:

	def __init__(self, atom3i):
		self.atom3i = atom3i
		self.cb = atom3i.cb
		self.ASGroot = atom3i.ASGroot
		
		self.UI_RootZoneNode = ZoneNode('root', [-10000, -10000,
																						 sys.maxint, sys.maxint], 
																		None, [atom3i.UI_Statechart])
		
#	def getZoneUI(self, event):
#		dc = self.cb.getCanvas()
#		x = dc.canvasx(event.x)
#		y = dc.canvasy(event.y)
#		#print 'user clicked at', x, y
#		
#		return self.UI_RootZoneNode.getUI_StatechartsAtCoords(x, y)
#		
		
	def createZone(self, nameString, boxCoordList, UI_Statechart):
		ZoneNode(nameString, boxCoordList, self.UI_RootZoneNode, UI_Statechart)

	def __call__(self, keyName, event):
		""" 
		Take the binded key/button name, the event, and send them to the UI 
		in the zone in which the event coordinates correspond
		NOTE: could be more than one UI statechart
		"""
		dc = self.cb.getCanvas()
		x = dc.canvasx(event.x)
		y = dc.canvasy(event.y)		
		
		UI_list = self.UI_RootZoneNode.getUI_StatechartsAtCoords(x, y)
		if(UI_list == None):
			print 'ERROR: could not find a UI handler for event', event.__dict__, 
			print 'in file', __file__	
			
	  # Found the UI behaviour statecharts for the clicked zone, send event		
		for UI in UI_list:
			#print 'sending', keyName
			UI.event(keyName, event)  


class ZoneNode:
	
	def __init__(self, nameString, boxCoordList, parentInstance, 
							 UI_StatechartList):
		
		self.__nameString = nameString		
		self.__UI_StatechartList = UI_StatechartList	
		
		self.__children = []
		
		if(parentInstance):
			self.__parent = parentInstance
			parentInstance.children.append(self)
			self.updateZoneBoundary(boxCoordList)
		else:
			self.__parent = None
 			self.__boxCoordList = boxCoordList	
				
	def deleteZoneNode(self):
		""" Removes the zone node from parent and deletes children """
		for child in self.__children:
			child.deleteNode()
		self.__parent.__children.remove(self)
		
	def updateZoneBoundary(self, boxCoordList):
		"""
		Coordinate box within which this UI behaviour statechart zone is active
		boxCoordList = [x0, y0, x1, y1]
		Where x0, y0 are the top left, and x1, y1 are the bottom right
		NOTE: Child zones must be a subset of their parents
		todo: what happens to children if you modify parent???
		"""
		x0, y0, x1, y1 = self.__parent.__boxCoordList
		x2, y2, x3, y3 = boxCoordList
		if(x0 > x2 or y0 > y2 or x1 < x3 or y1 < y3):
			raise Exception, "Update error: zone box must be subset of parent box"
		self.__boxCoordList = boxCoordList
		
	def getUI_StatechartsAtCoords(self, x, y):
		"""
		Returns the deepest zone UI behaviour statechart at coords x, y 
		"""
		x0, y0, x1, y1 = self.__boxCoordList
		if(x >= x0 and x <= x1 and y >= y0 and y <= y1):
			for child in self.__children:
				UI_StatechartList = child.getUI_StatechartsAtCoords(x, y)
				if(UI_StatechartList):
					return UI_StatechartList
					
			#print 'Got UI at', x, y, 'it is', self.__nameString
			return self.__UI_StatechartList
		else:
			return None
			
		
		