"""
atom3NoSplash.py

This script bootstraps AToM3 and displays a splash screen
while the AToM3 files are imported.

NOTE: ATOM3.py must reside in the 'Kernel' path, and __init__.py must be in 
the same directory as this script file.

Created August 11, 2004 by Denis Dube
Modified January 26, 2005 by Denis: Added minimum time delay & MSDL image
Modified Feb 15, 2005 by Denis: Split script in two, this version without splash
Modified Feb 16, 2005 by Denis: Added uncaught exception handling
"""

import os, sys, Tkinter, time
timeElapsed = time.time()


# Get the path to the Kernel and stick in the sys.path for import goodness
from __init__ import BASE_PATH
kernelPath = os.path.normpath( os.path.join( BASE_PATH, 'Kernel' ) )
sys.path.append( kernelPath )

# Catch otherwise uncaught exceptions
import Kernel.ErrorHandlers.loadErrorHandlers
from Kernel.ErrorHandlers.exceptionHookFriendlyTk import exceptionHookFriendlyTk
TkRoot = exceptionHookFriendlyTk()
TkRoot.configure( cursor='watch' )

# Make sure that Tk's double-click and next/previous word
# operations use our definition of a word (i.e. an identifier)
try:
  tk = TkRoot.tk
  tk.call('tcl_wordBreakAfter', 'a b', 0) # make sure word.tcl is loaded
  tk.call('set', 'tcl_wordchars', '[a-zA-Z0-9_]')
  tk.call('set', 'tcl_nonwordchars', '[^a-zA-Z0-9_]')
except:
  print 'ERROR: Unable to set custom double-click behaviour for text-widgets'

# No, you may not kill the TkRoot prematurely :p
def handler(): pass
TkRoot.protocol("WM_DELETE_WINDOW", handler )

TkRoot.geometry( '800x600+0+0' )
TkRoot.title("Loading AToM3")
TkRoot.update() # Draw on the screen

try:
  import ATOM3 # Import the juggernaught known as ATOM3
except:
  raise
  print "This message should only appear if you are using AToM3 for the first time"
  TkRoot.destroy()
  sys.exit()
  

# Start ATOM3 Kernel
if len(sys.argv) == 1:
    ATOM3.ATOM3( TkRoot, None , 1, 1).mainloop()
else:
    ATOM3.ATOM3( TkRoot, sys.argv[1] , 1, 1).mainloop()
print "\nClosing AToM3 - A Tool for Multi-formalism and Meta-Modelling\n"



  
    
