package qoca;
// $Id: QcConstants.java.cpp,v 1.5 2000/11/21 04:26:13 pmoulder Exp $

//============================================================================//
// Written by Sitt Sen Chok                                                   //
//----------------------------------------------------------------------------//
// The QOCA implementation is free software, but it is Copyright (C)          //
// 1994-1999 Monash University.  It is distributed under the terms of the GNU //
// General Public License.  See the file COPYING for copying permission.      //
//                                                                            //
// The QOCA toolkit and runtime are distributed under the terms of the GNU    //
// Library General Public License.  See the file COPYING.LIB for copying      //
// permissions for those files.                                               //
//                                                                            //
// If those licencing arrangements are not satisfactory, please contact us!   //
// We are willing to offer alternative arrangements, if the need should arise.//
//                                                                            //
// THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED OR  //
// IMPLIED.  ANY USE IS AT YOUR OWN RISK.                                     //
//                                                                            //
// Permission is hereby granted to use or copy this program for any purpose,  //
// provided the above notices are retained on all copies.  Permission to      //
// modify the code and to distribute modified code is granted, provided the   //
// above notices are retained, and a notice that the code was modified is     //
// included with the above copyright notice.                                  //
//============================================================================//

class QcConstants
{
	public static final int fQuantum = 64;
	public static final float fNearEps = 1e-5f;
	public static final float fEps = 1e-8f;
	public static final int fHashTableInitCapacity = 8;
	public static final float fDefaultLoadFactor = 1.0f;
	public static final int fVectorInitCapacity = 256;
	public static final int fVectorCapacityIncrement = 64;
	public static final int fMaxLoopCycles = 10000;
	public static final int fOneMegaBytes = 1048576;
	public static final int fOneKiloBytes = 1024;

	/** true iff we are to check preconditions. */
#ifdef qcCheckPre
	public static final boolean fCheckPre = true;
	public static final boolean fCheckInternalPre = true;
	public static final boolean fCheckExpensivePre = true;
#else
	public static final boolean fCheckPre = false;
	public static final boolean fCheckInternalPre = false;
	public static final boolean fCheckExpensivePre = false;
#endif

	/** true iff we are to check postconditions and invariants. */
#ifdef qcCheckPost
	public static final boolean fCheckPost = true;
	public static final boolean fCheckInternalPost = true;
	public static final boolean fCheckExpensivePost = true;
#else
	public static final boolean fCheckPost = false;
	public static final boolean fCheckInternalPost = false;
	public static final boolean fCheckExpensivePost = false;
#endif
}

/*
  Local Variables:
  mode:java
  c-file-style:"java8"
  fill-column:80
  End:
  vim: set filetype=java :
*/
